/***************************************************************************
                                 config.h
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GBLICONFIG_H
#define GBLICONFIG_H

// run on normal computer for debugging/development
//#define GBLI_DEVEL

// BLC - Best Linux Configurator
#define GBLI_STANDALONE

// server specific things, e.g. install types, Services Page etc.
#define GBLI_SERVER

// IPv6 and multiply network adapters support
#define GBLI_IPv6

// use rpm-3 in Live and in system
//#define GBLI_RPM3

// use XFree-4 in Live and in system
#define XFREE_4

// use Alsa instead of OSS
//#define ALSA_SOUND

// use 'devfs' both in installation and in running system
//#define DEVFS
#ifndef GBLI_SERVER
	#define DESKTOP_DEMO
#endif
//changes which is required only for desktop-demo version
#define USE_NEW_KERNEL_DIVISION
//kernel is divided to BOOT,desktop and server versions,
//where smp is anabled in both

// for advanced partition editing (shows sectors etc)
//#define ADVANCED_SIZE
#ifdef ADVANCED_SIZE
	#define ADVANCED_SIZE_VIEW
#endif


// Common strings definitions

#include <qstring.h>
const QString TEXTURE = "texture.jpg";

#define GBLI_DATA_PATH "/usr/share/blc"

// Where to install
#ifdef GBLI_DEVEL
	const QString NEWROOT = "/mnt/root";
#else
	#ifdef GBLI_STANDALONE
		const QString NEWROOT = "/";
	#else
		const QString NEWROOT = "/mnt/root";
	#endif
#endif

// Where take rpms
#ifdef GBLI_STANDALONE
	const QString INSTALL_SOURCE = "/tmp/install";
#else
	#ifdef GBLI_DEVEL
		const QString INSTALL_SOURCE = "/data/projects/BL2X/install";
	#else
		const QString INSTALL_SOURCE = "/tmp/install";
	#endif
#endif

#define CONF_MODULES "/etc/modules.conf"

#ifdef GBLI_DEVEL
        #define GBLI_VERSION "internal 2.2a"
#else
        #define GBLI_VERSION "2.2a"
#endif


#endif // common
