/***************************************************************************
                               gbli.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "gbli.h"
#include "config.h"
#include "swapper.h"
#include "partitionview.h"
#include "mountpoint.h"
#include "language.h"
#include "windowsconfig.h"
#include "servicessetup.h"

#include <qtooltip.h>

#define PROGRESS_HEIGHT 18
#define ICONS_BORDER 40

// constructor: setups translator and creates pages
GBLI::GBLI()
    : QWizard( 0, 0,
#ifdef GBLI_DEVEL
    TRUE
#else
TRUE/*    FALSE*/
#endif
   ), translator(NULL), installFinished(false),
	installGoing( false ), allFinished( false ), curCheckPoint(0),
	gotWindowsSettings( false )
{

    setFont( QFont::defaultFont() );
    setupTranslator();
    setGeometry( 0, 0, 640, 480 );
    setFixedSize( 640, 480 );
		setFocusPolicy( QWidget::StrongFocus );

		int tmp[32] = { 1, 2, 3, 5, 7, 10, 12,
										15, 17, 20, 25, 30, 40, 50, 60,
										70, 80, 85, 90, 92, 94, 96, 98,
										100 };
		aiProgrCheck = tmp;

		int tmp2[32] = { 5654, 48551, 48663, 53605, 65258, 80399, 85948,
			85980, 113002, 123674, 150691, 169766, 246510, 328354, 417531,
			490934, 582837, 637762, 655251, 660277, 670048, 700571, 721014,
			750000 };
		aiProgrTimes = tmp2;

    init();
		layOutInit();

		setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
}

GBLI::~GBLI()
{
}

// load the translator for current setup in environment language
void GBLI::setupTranslator(){
		QFont::locale_init();

    // set up the language
		if( translator ){
			qApp->removeTranslator( translator );
			delete translator;
		}
		translator = new QTranslator( qApp );
		if( Language::lang ){
      QString localePath = "/usr/share/locale/"+ QString(*Language::lang->key) +"/LC_MESSAGES/";
      if( translator->load( "gbli.qm", localePath ) )
  			qApp->installTranslator( translator );
    }

//    nextButton()->setText( tr( ">>" ) );
//    backButton()->setText( tr( "<<" ) );
//    finishButton()->setText( tr( "Finish" ) );
/*		QFont font( QFont::defaultFont() );
		font.setPointSize( 16 );
    nextButton()->setFont( font );
    backButton()->setFont( font );*/

    nextButton()->setPixmap( LIconLoader::loadIcon( "next.gif" ) );
    backButton()->setPixmap( LIconLoader::loadIcon( "previous.gif" ) );
#ifndef GBLI_STANDALONE
		finishButton()->setPixmap( LIconLoader::loadIcon( "exit.gif" ) );
#else
		finishButton()->setText( tr( "Finish" ) );
#endif
    nextButton()->setAutoMask( true );
    backButton()->setAutoMask( true );
    finishButton()->setAutoMask( true );

		QFont font = QToolTip::font();
		font.setPointSize( Language::iNormalFontSize );
		QToolTip::setFont( font );
		QToolTip::add( backButton(), tr( "Go to the previous step" ) );
		QToolTip::add( nextButton(), tr( "Go to the next step" ) );
#ifndef GBLI_STANDALONE
		QToolTip::add( finishButton(), tr( "Finish installation" ) );
		cancelButton()->hide();
#else
		QToolTip::add( finishButton(), tr( "Finish changing system settings" ) );
		QToolTip::add( cancelButton(), tr( "Cancel changing system settings" ) );
#endif

    helpButton()->setText( tr( "Help" ) +" ;-)" );
    helpButton()->hide();

		finishButton()->hide();
#ifdef GBLI_DEVEL
		finishButton()->setEnabled( true );
#else
		finishButton()->setEnabled( false );
#endif

		QApplication::syncX();
		QApplication::flushX();
		
		EtcFiles etcForKDE( "" );
		etcForKDE.setupRightCharset( "/root/.kderc" );
}

void GBLI::ConfCleanups()
{
//        sed -e "/ulimit -n/d" sysctl.conf >sysctl.conf.save
//this cleanup is required to fix some /etc/profile ulimit-commands
	int iRet = system( ("chroot "+ NEWROOT +" /bin/sh -c \"cp -f /etc/profile /etc/profile.save\"").latin1());
			iRet = system( ("chroot "+ NEWROOT +" /bin/sh -c \"sed -e \\\"/ulimit -n/d\\\" /etc/profile.save >/etc/profile\"").latin1());	
}
// init pages, create some of them and then call setupPages2()
void GBLI::init(){
    videoCard = 0;
    monitor = 0;
    videoMode = 0;
    target = 0;
    diskpartitioner = 0;
    disksel = 0;
    partitionselRoot = 0;
    partitionInfo = 0;
    installselect = 0;
    updatePage = 0;
    packageselect = 0;
    mouse = 0;
    modem = 0;
    ISP = 0;
//    network = 0;
    keyboard = 0;
//    timezone = 0;
    createusers = 0;
    grub = 0;
    sound = 0;
    finalpage = 0;
    prncfg = 0;
		modulessetup = 0;
#ifdef GBLI_SERVER
		services = 0;
#endif

		if( QDir( NEWROOT ).exists() ){
	    // helpful while debugging
#ifndef GBLI_DEVEL
	#ifndef GBLI_STANDALONE
  	  PartitionInfo::unMounting();
	#endif
#else
	#ifdef GBLI_STANDALONE
			// for testing on Maddies computer
  	  system( ("mount /dev/hdd1 "+ NEWROOT +" >/dev/null 2>&1").latin1() );
	#endif
#endif
    }else{
#ifndef GBLI_STANDALONE
	    // create some folders we will need
  	  ::mkdir( NEWROOT.latin1(), 0777 ); // for new root
    	::mkdir( "/mnt/tmp", 0777 );  // to test for existing partitions
#endif
		}

#ifndef GBLI_DEVEL
    static Atom noDecoration = ::XInternAtom( qt_xdisplay(),
					       "KWM_WIN_DECORATION", False );
		long l = 0;// 0 == KWM::noDecoration
    XChangeProperty( qt_xdisplay(), winId(), noDecoration, noDecoration, 32,
		  PropModeReplace, (unsigned char *)&l, 1 );
#endif

		QFont f1( QFont::defaultFont() );
		f1.setPointSize( Language::iNormalFontSize - 2 );
		beginLabel = new QLabel( "12:20", this );
		beginLabel->setAutoMask( true );
		beginLabel->setFont( f1 );

    progressBar = new QProgressBar( this );
		progressBar->setMinimumHeight( PROGRESS_HEIGHT );
		progressBar->setMaximumHeight( PROGRESS_HEIGHT );
		progressBar->setIndicatorFollowsStyle( true );
		QFont font( QFont::defaultFont() );
		font.setPointSize( Language::iNormalFontSize - 2 );
    progressBar->setFont( font );
#ifdef GBLI_DEVEL
		progressBar->setTotalSteps( 100 );
		progressBar->setProgress( 35 );
#endif
		progressBar->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );

		endLabel = new QLabel( "XX:XX", this );
		endLabel->setAutoMask( true );
		endLabel->setFont( f1 );

		hideProgressRow();

    titleLabel = new QLabel( this );
		titleLabel->setAlignment( AlignBottom | AlignHCenter );
		titleLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );
		titleLabel->setAutoMask( true );
//		font.setFamily( "helvetica" );
//		font.setFamily( "gothic" );
		font.setWeight( QFont::Bold );
		font.setPointSize( Language::iBigFontSize );
//printf( "Set font (title): %s, %d!\n", font.family().ascii(), font.pointSize() );
//printf( "Set actual font (title): %s, %d!\n", QFontInfo( font ).family().ascii(), QFontInfo( font ).pointSize() );
    titleLabel->setFont( font );

    penguinLabel = new QLabel( this );
	  penguinLabel->setPixmap( LIconLoader::loadStepIcon( "arrow_hand.gif" /*"penguin.gif"*/ ) );
		penguinLabel->adjustSize();
		penguinLabel->setAutoMask( true );

		// hot keys setup
    QAccel * a = new QAccel( this );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_Delete ),
		    this, SLOT(reboot()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_D ),
		    this, SLOT(screendump()) );
    a->connectItem( a->insertItem( Qt::ALT + Qt::Key_X ),
		    this, SLOT(xterm()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_U ),
		    this, SLOT(decreaseDebug()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_I ),
		    this, SLOT(increaseDebug()) );

    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_N ),
		    this, SLOT(next()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::ALT + Qt::Key_B ),
		    this, SLOT(back()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::Key_Right ),
		    this, SLOT(next()) );
    a->connectItem( a->insertItem( Qt::CTRL + Qt::Key_Left ),
		    this, SLOT(back()) );

// this section is for BLC only since it requires only some small number of pages
#ifdef GBLI_STANDALONE
    // set up network
		net = new NetworkPage( this, "networking" );
		addPage( net, tr( "Configure networking" ), "networking" );
		connect(net, SIGNAL(hide()), this, SLOT(net->updateInfo()));
//		net->setHelpName( "node21.html" );

//Services setup to BLC
 #ifdef GBLI_SERVER
		services = new ServicesSetup( QString( GBLI_DATA_PATH ) +"/data/server_services.cfg",
			net->getNetinfo(), this, "servicessetup" );
  	addPage( services, tr( "Services setup" ), "servicessetup" );
 #endif
//*********************************************************************

		updatePage = new UpgradePage(NULL, PartitionSelector::OnlyRootMode, this, "installationpath");
		updatePage->hide();

	  installselect = new InstallSelect( this, "installationtype" );
		installselect->hide();

    packageselect = new PackageSelect( this, installselect, "installationtype" );
    addPage( packageselect, tr( "Select individual packages" ), "installationtype" );
	  setNextEnabled( packageselect, false );
    connect( installselect, SIGNAL( installationFinished() ),
	     packageselect, SLOT( updateFinished() ) );
    connect( packageselect, SIGNAL( updateStarted() ),
	     this, SLOT( startUpdate() ) );
//    setFinishEnabled( packageselect, false );

		return;
#endif

//********************* TESTING ZONE **********************//
#ifdef GBLI_DEVEL
/*
    // partition disks
    diskpartitioner = new DiskPartitioner( this, "installationpath" );
    connect( diskpartitioner, SIGNAL( nextEnabled(QWidget*, bool) ),
       this, SLOT( setNextEnabled(QWidget*, bool) ) );
		diskpartitioner->setHelpName( "node10.html" );

    target = new Target( diskpartitioner->getView(), this, "installationpath" );
    addPage( target, tr( "Select installation path" ), "installationpath" );
		target->setHelpName( "node10.html" );

		updatePage = new UpgradePage(diskpartitioner->getView(), PartitionSelector::OnlyRootMode, this, "installationpath", target);
    addPage(updatePage, tr("Update existing Linux OS"), "installationpath");

    // select packages
	  installselect = new InstallSelect( this, "installationtype" );
    connect( installselect, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
  	addPage( installselect, tr( "Select installation type" ), "installationtype" );
//		installselect->setHelpName( "node18.html" );
				installselect->setHelpName( "node11.html" );

    connect( installselect, SIGNAL(installationFinished()),
	     this, SLOT( packageInstallationFinished() ) );
    connect( installselect, SIGNAL( prevEnabled(QWidget*, bool) ),
	     this, SLOT( setBackEnabled(QWidget*, bool) ) );

    connect( installselect, SIGNAL( showProgressBar() ),
	     this, SLOT( showProgressRow() ) );
    connect( installselect, SIGNAL( hideProgressBar() ),
	     this, SLOT( hideProgressRow() ) );
    connect( installselect, SIGNAL( resetProgress() ),
	     this, SLOT( setProgress() ) );
    connect( installselect, SIGNAL( setTotalSteps(int) ),
	     progressBar, SLOT( setTotalSteps(int) ) );
    connect( installselect, SIGNAL( setProgress(int) ),
	     this, SLOT( setProgress(int) ) );

    packageselect = new PackageSelect( this, installselect, "installationtype" );
    addPage( packageselect, tr( "Select individual packages" ), "installationtype" );
    connect( packageselect, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
//		packageselect->setHelpName( "node18.html" );
		packageselect->setHelpName( "node11.html" );

    mouse = new Mouse( this, "mouse" );
    addPage( mouse, tr( "Configure mouse" ), "mouse" );
		setNextEnabled( mouse, false );
		mouse->setHelpName( "node8.html" );
*/
#endif
//********************END OF TESTING ZONE *******************//
  	// Mouse setup

    mouse = new Mouse( this, "mouse" );
    addPage( mouse, tr( "Configure mouse" ), "mouse" );
		setBackEnabled( mouse, false );
		//mouse->setHelpName( "node14.html" );
		mouse->setHelpName( "node9.html" );//Fixed the node number, 8 was before,dk

		// additional modules setup
		modulessetup = new AddModulesPage( this, "scsi" );
		addPage( modulessetup, tr( "Additional modules" ), "scsi" );
//		modulessetup->setHelpName( "node15.html" );
#ifndef GBLI_SERVER
		modulessetup->setHelpName( "node10.html" ); //Fixed the node number, 9 was before,dk
#else
    		modulessetup->setHelpName( "node11.html" ); //Fixed the node number, 10 was before,dk
#endif

    // partition disks
    diskpartitioner = new DiskPartitioner( this, "installationpath" );
    connect( diskpartitioner, SIGNAL( nextEnabled(QWidget*, bool) ),
       this, SLOT( setNextEnabled(QWidget*, bool) ) );
//		diskpartitioner->setHelpName( "node17.html" );

#ifndef GBLI_SERVER
		diskpartitioner->setHelpName( "node11.html" );//Fixed the node number, 10 was before,dk
#else
		diskpartitioner->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#endif

    // target
    target = new Target( diskpartitioner->getView(), this, "installationpath" );
    addPage( target, tr( "Select installation path" ), "installationpath" );
//		target->setHelpName( "node17.html" );

#ifndef GBLI_SERVER
		target->setHelpName( "node11.html" );//Fixed the node number, 10 was before,dk
#else
		target->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#endif


    // diskpartitioner is _behind_ target, naturally
    addPage( diskpartitioner, tr( "Partition disks" ), "installationpath" );

    // disk selector
    disksel = new DiskSelector( diskpartitioner->getView(), this, "installationpath" );
    connect( disksel, SIGNAL( nextEnabled(QWidget*, bool) ),
       this, SLOT( setNextEnabled(QWidget*, bool) ) );
    connect( diskpartitioner, SIGNAL( changePartitionTable() ),
       disksel, SLOT( partitionTableChanged() ) );
    addPage( disksel, tr("Select hard disk"), "installationpath" );
//		disksel->setHelpName( "node17.html" );

#ifndef GBLI_SERVER
		disksel->setHelpName( "node11.html" );//Fixed the node number, 10 was before,dk
#else
		disksel->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#endif


    // select root partition
    partitionselRoot = new PartitionSelector( diskpartitioner->getView(), PartitionSelector::OnlyRootMode, this, "installationpath");
    addPage( partitionselRoot, tr( "Root partition" ), "installationpath" );
//		partitionselRoot->setHelpName( "node17.html" );
#ifndef GBLI_SERVER
		partitionselRoot->setHelpName( "node11.html" );//Fixed the node number, 10 was before,dk
#else
		partitionselRoot->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#endif

		// update page
		updatePage = new UpgradePage(diskpartitioner->getView(), PartitionSelector::OnlyRootMode, this, "installationpath", target);
    addPage(updatePage, tr("Update existing Linux OS"), "installationpath");

    // partition info
    partitionInfo = new PartitionInfo( diskpartitioner->getView(), this, "installationpath" );
    connect( partitionInfo, SIGNAL( nextEnabled(QWidget*, bool) ),
       this, SLOT( setNextEnabled(QWidget*, bool) ) );
    addPage( partitionInfo, tr( "Partition information" ), "installationpath" );
//		partitionInfo->setHelpName( "node17.html" );
#ifndef GBLI_SERVER
		partitionInfo->setHelpName( "node11.html" );//Fixed the node number, 10 was before,dk
#else
		partitionInfo->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#endif


//    QTimer::singleShot( 1000, ((GBLI*)this), SLOT(setupPages2()) );

		// re-init mouse to try to fix laptop screens problems
		QTimer::singleShot( 10, mouse, SLOT(tellXServer()) );

		// earlier it was as "shot", but it makes bad impression to the customers

		setupPages2();
}

void GBLI::setupPages2(){

    // select packages
	  installselect = new InstallSelect( this, "installationtype" );
    connect( installselect, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
  	addPage( installselect, tr( "Select installation type" ), "installationtype" );
//		installselect->setHelpName( "node18.html" );
#ifndef GBLI_SERVER
				installselect->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#else
				installselect->setHelpName( "node13.html" );//Fixed the node number, 12 was before,dk
#endif


    connect( installselect, SIGNAL(installationFinished()),
	     this, SLOT( packageInstallationFinished() ) );
    connect( installselect, SIGNAL( prevEnabled(QWidget*, bool) ),
	     this, SLOT( setBackEnabled(QWidget*, bool) ) );

    connect( installselect, SIGNAL( showProgressBar() ),
	     this, SLOT( showProgressRow() ) );
    connect( installselect, SIGNAL( hideProgressBar() ),
	     this, SLOT( hideProgressRow() ) );
    connect( installselect, SIGNAL( resetProgress() ),
	     this, SLOT( setProgress() ) );
    connect( installselect, SIGNAL( setTotalSteps(int) ),
	     progressBar, SLOT( setTotalSteps(int) ) );
    connect( installselect, SIGNAL( setProgress(int) ),
	     this, SLOT( setProgress(int) ) );

    packageselect = new PackageSelect( this, installselect, "installationtype" );
    addPage( packageselect, tr( "Select individual packages" ), "installationtype" );
    connect( packageselect, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
//		packageselect->setHelpName( "node18.html" );
#ifndef GBLI_SERVER
		packageselect->setHelpName( "node12.html" );//Fixed the node number, 11 was before,dk
#else
		packageselect->setHelpName( "node13.html" );//Fixed the node number, 12 was before,dk
#endif


    // keyboard
    keyboard = new Keyboard( this, "keyboard" );
    addPage( keyboard, tr( "Keyboard type" ), "keyboard" );
    connect( installselect, SIGNAL(enableKeyboardPass(bool)),
      keyboard, SLOT(enableNext(bool)) );
//		keyboard->setHelpName( "node19.html" );
#ifndef GBLI_SERVER
		keyboard->setHelpName( "node13.html" );//Fixed the node number, 12 was before,dk
#else
		keyboard->setHelpName( "node14.html" );//Fixed the node number, 13 was before,dk
#endif

    // set up network
		net = new NetworkPage( this, "networking" );
		addPage( net, tr( "Configure networking" ), "networking" );
//		connect(net, SIGNAL(hide()), this, SLOT(net->updateInfo()));
//		net->setHelpName( "node21.html" );
#ifndef GBLI_SERVER
		net->setHelpName( "node14.html" );//Fixed the node number, 13 was before,dk
#else
		net->setHelpName( "node15.html" );//Fixed the node number, 14 was before,dk
#endif


#ifdef GBLI_SERVER
		services = new ServicesSetup( QString( GBLI_DATA_PATH ) +"/data/server_services.cfg",
			net->getNetinfo(), this, "servicessetup" );
	  addPage( services, tr( "Services setup" ), "servicessetup" );
services->setHelpName( "node10.html" );//Added by dk
#endif

    // setup modem
    modem = new Modem( this, mouse, "modem" );
    connect( modem, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
    addPage( modem, tr( "Configure modem" ), "modem" );
//		modem->setHelpName( "node23.html" );
#ifndef GBLI_SERVER
		modem->setHelpName( "node15.html" );//Fixed the node number, 14 was before,dk
#else
		modem->setHelpName( "node16.html" );//Fixed the node number, 15 was before,dk
#endif

    // setup ISP
    ISP = new ISPPage( this, "modem" );
    addPage( ISP, tr("Internet provider"), "modem" );
//		ISP->setHelpName( "node23.html" );
#ifndef GBLI_SERVER
		ISP->setHelpName( "node15.html" );//Fixed the node number, 14 was before,dk
#else
		ISP->setHelpName( "node16.html" );//Fixed the node number, 16 was before,dk
#endif


    // setup some users
    createusers = new LCreateUsers( this, "users" );
    connect( createusers, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
    addPage( createusers, tr( "Setup users" ), "users" );
//		createusers->setHelpName( "node25.html" );
#ifndef GBLI_SERVER
		createusers->setHelpName( "node16.html" );//Fixed the node number, 15 was before,dk
#else
		createusers->setHelpName( "node17.html" );//Fixed the node number, 16 was before,dk
#endif


    // select video card and stuff
    videoCard = new LVideoCard( this, "videocard"  );
    monitor = new LMonitor( this, "monitor"  );
    videoMode = new LVideoModeSelector( monitor, videoCard,
      					mouse, keyboard, this, "monitor" );
    addPage( videoCard, tr( "Select video card" ), "videocard" );
//		videoCard->setHelpName( "node20.html" );
#ifndef GBLI_SERVER
		videoCard->setHelpName( "node17.html" );//Fixed the node number, 16 was before,dk
#else
		videoCard->setHelpName( "node18.html" );//Fixed the node number, 17 was before,dk
#endif


    addPage( monitor, tr( "Select monitor" ), "monitor" );
//		monitor->setHelpName( "node20.html" );
#ifndef GBLI_SERVER
 		monitor->setHelpName( "node17.html" );//Fixed the node number, 16 was before,dk
#else
 		monitor->setHelpName( "node18.html" );//Fixed the node number, 17 was before,dk
#endif

    addPage( videoMode, tr( "Select video mode" ), "monitor" );
//		videoMode->setHelpName( "node20.html" );
#ifndef GBLI_SERVER
		videoMode->setHelpName( "node17.html" );//Fixed the node number, 16 was before,dk
#else
		videoMode->setHelpName( "node18.html" );//Fixed the node number, 17 was before,dk
#endif


		if( videoCard->getSoftProbed() )
			videoCard->setStatus( GBLIPage::Good );

//    connect( videoCard, SIGNAL(nextAvailable(QWidget *,bool)),
//  	   this, SLOT(setNextEnabled(QWidget *,bool)) );

    // setup sound card
//#ifndef GBLI_DEVEL
#ifdef ALSA_SOUND
    sound = new SoundAlsa( this, "soundcard" );
    addPage(sound, tr("Test sound card"), "soundcard" );
#else
    sound = new LSound( this, "soundcard" );
    addPage(sound, tr("Test sound card"), "soundcard" );
		if( sound->b_enable )
			sound->setStatus( GBLIPage::Good );
#endif
//#endif
//		sound->setHelpName( "node16.html" );
#ifndef GBLI_SERVER
		sound->setHelpName( "node18.html" );//Fixed by dk, was 17 before
#endif

    // set up printer
    prncfg = new PrinterCfg( this, "printer", net);
		addPage( prncfg, tr( "Configure printer" ), "printer" );
//		prncfg->setHelpName( "node24.html" );
		prncfg->setHelpName( "node19.html" );//Fixed by dk, was 18 before

    // bootloader
    grub = new GRUB( diskpartitioner->getView(), this, "bootloader" );
    addPage( grub, tr("Booting Linux"), "bootloader" );
    connect( grub, SIGNAL( nextEnabled(QWidget*, bool) ),
	     this, SLOT( setNextEnabled(QWidget*, bool) ) );
//		grub->setHelpName( "node22.html" );
		grub->setHelpName( "node20.html" );//Fixed by dk, was 19 before

    // set up timezone
//    timezone = new TimeZone( this, "timezones" );
//    addPage( timezone, tr( "Configure time" ), "timezones" );

//	  QTimer::singleShot( 500, timezone, SLOT(prepare()) );

//		QWidget *stubWidg = new QWidget( this, "games" );
//		addPage( stubWidg, "Play a game!", "games" );

		// last page with the manual
		//change manual to index.html
		finalpage = new FinalPage( this, "manual" );
//#ifdef GBLI_DEVEL
//		Log::logMain(2,"finalpage->SetDocument(index.html)");
//#endif
    if (finalpage!=NULL) finalpage->setDocument("index.html");
		addPage( finalpage, tr( "While SOT Linux is being installed..." ), "manual" );
	  setBackEnabled( finalpage, FALSE );
	  setNextEnabled( finalpage, FALSE );
		finalpage->setStatus( GBLIPage::Good );
    setFinishEnabled( finalpage,
#ifdef GBLI_DEVEL
			TRUE );			
#else
			FALSE );
#endif
//    setFinish( finalpage, true );

		// setup keuboard, so that user can start using his favourite
		// layout right away
		keyboard->init();
}

// checks if page can be shown in current context
bool GBLI::appropriate( QWidget * w ) const {
//	printf("%d\n", target->selected());

	// new mechanizm - it simplifies a lot, but should be fixed all other places,
  // so that gbli reaches this places at all
	if( w->inherits("GBLIPage") ){
		StepLabel *l;
		l = ((GBLIPage*)w)->getStepLabel();
		if( l && l->getStatus() == GBLIPage::Disabled )
			return false;
	}

	if( w == modulessetup ){
		return true;
	}

//printf( "appropriate - %s\n", w->name() );

#ifdef GBLI_DEVEL
//	((GBLI*)this)->packageInstallationFinished();
#endif

// check that everything is done at the end
#ifndef GBLI_DEVEL
	if( w == grub || w == finalpage ){
#else
	if( w == modulessetup || w == grub ){
#endif
		((GBLI*)this)->checkStates();
	}

	// final page can be accessed directly, but then it shouldn't allow
  // to go to grub page
	if( w == grub )
	  ((GBLI*)this)->setBackEnabled( finalpage, true );

	if( w == finalpage ){
		finalpage->setDocument( "index.html" );
		return true;
	}

	StepLabel *lab;
	if( w->inherits("GBLIPage") )
		lab = ((GBLIPage*)w)->getStepLabel();
	else
		lab = lblSteps.find( w->name() );
	if( lab && lab->getStatus() == GBLIPage::Good && !lab->getVisited() ){
		lab->setVisited( true );
		return false;
	}

	if( w == mouse || w == finalpage )
		return true;

	if( w == packageselect ){
#ifndef GBLI_STANDALONE
		if( installGoing ) return false;
#else
		if( InstallSelect::blUpdate ){
			bool blshow = packageselect->findInstallSource() == INST_OK;
			if(!blshow)
			{
				((GBLIPage*)w)->setStatus(GBLIPage::Bad);
				lab->setVisited(false);
			}
Log::logMain(32,  "blshow: %d\n", blshow );
			return blshow;
		}else
			return false; // what the f**k? BLC is always in update mode
#endif
		return installselect->isCustom();
	}

  if ( w == target ){
		if( installGoing ) return false;
	}

  if ( w == diskpartitioner ){
		if( installGoing || target->selected() == Target::Update ) return false;
//		printf("diskpartitioner\n");
		return target->selected() == Target::Custom;
	}

  if ( w == disksel ){
		if( installGoing || target->selected() == Target::Update ) return false;
//		printf("disksel\n");
		return target->selected() == Target::Disk;
	}

  if ( w == partitionselRoot ) {
		if ( installGoing || target->selected() == Target::Update ) return false;
  	if ( target->selected() != Target::Partitions ) {
 	    // if the user did not chose a root partition yet, we have
 	    // to ask him
 	    return MountPoints::mountPartition( "/" ).isEmpty();
  	}else{
//			printf("partitionselRoot\n");
	    QApplication::setOverrideCursor( waitCursor );
	    diskpartitioner->getView()->defaultPartitionTable();
			if( QApplication::overrideCursor() )
		    QApplication::restoreOverrideCursor();
	    return true;
	  }
  }

  if ( w == partitionInfo ){
		if( installGoing ) return false;
 		return ( target->selected() != Target::Disk && target->selected() != Target::Update);
	}

  if ( w == updatePage )
	{
		if( installGoing ) return false;
//		printf("partitionselRoot\n");
 		return InstallSelect::blUpdate;
	}

  if( w == installselect ){
		if( installGoing ) return false;
		if( !InstallSelect::blUpdate ){
			((GBLI*)this)->setTitle( installselect, tr( "Select installation type" ) );
			partitionInfo->setDone();
#ifndef GBLI_DEVEL
  	  partitionInfo->doMounting();

			system(("(mkdir -p "+ NEWROOT + "/etc/sysconfig; cp -af /etc/sysconfig/clock "+ NEWROOT +"/etc/sysconfig/clock)").ascii() ); // initscripts need it during installation
#endif
		}else{
			((GBLI*)this)->setTitle( installselect, tr( "Update existing Linux OS" ) );
		}
 	}

	// disable all pages which are not needed without X
	if( !installselect->withX &&
			(w == videoCard || /*w == prncfg ||*/ w == sound ||
			 w == monitor || w == videoMode ) ){
		videoCard->setStatus( GBLIPage::Disabled );
		monitor->setStatus( GBLIPage::Disabled );
		videoMode->setStatus( GBLIPage::Disabled );
//		prncfg->setStatus( GBLIPage::Disabled );
		sound->setStatus( GBLIPage::Disabled );
		return FALSE;
	}

  if( w == monitor || w == videoMode ){
		bool noSVGA = videoCard->defaultVGA16();
		if( noSVGA ){
			monitor->setStatus( GBLIPage::Disabled );
			videoMode->setStatus( GBLIPage::Disabled );
		}else{
			monitor->setStatus( GBLIPage::Bad );
			videoMode->setStatus( GBLIPage::Bad );
		}
	  return !noSVGA;
	}

  if( w == ISP ){
    modem->save();
    return ISP->visible();
  }

  return QWizard::appropriate( w );
}

// called on the beginning of packages installation to display progress bar
void GBLI::showProgressRow(){
//printf( "showProgress\n" );
	Log::logMain( 0, "%s\n", QDateTime::currentDateTime().toString().ascii() );
	setProgress( 0 );
	progressBar->show();
	beginLabel->show();
	timer.start();
	setTime( beginLabel, timer );
	endLabel->show();
	layOutIcons();
}

// after all packages are installed
void GBLI::hideProgressRow(){
//printf( "hideProgress\n" );
	Log::logMain( 0, "%s\n", QDateTime::currentDateTime().toString().ascii() );
	progressBar->hide();
	beginLabel->hide();
	endLabel->hide();
}

// change progress value
void GBLI::setProgress( int a_i ){
	int iMainMax = 750000;
	if( a_i ){
		progressBar->setProgress( a_i );
		if( aiProgrCheck[curCheckPoint] <= (a_i/10) ){
			double coef = (double)( (((double)aiProgrTimes[curCheckPoint]) *
				 ((double)1000)) / ((double)iMainMax) );
//printf( "iCur: %f, %f, %f, %f\n", coef, ((double)aiProgrTimes[curCheckPoint]),
//				 ((double)1000), ((double)iMainMax) );
			if( a_i >= 3 && coef > 0.0 ){
  			int iCur = (int)( ((double)timer.elapsed()) / ((double)coef) );
  			QTime newTime = timer.addSecs( iCur );
  			QString t1( QString::number( timer.hour() ) +":"+ QString::number( timer.minute() ) );
  			QString t2( QString::number( newTime.hour() ) +":"+ QString::number( newTime.minute() ) );
//  			Log::logMain( 1, "Time: %d\%, pr%d, c%d, %f, elaps%d, iCur%d, begin %s, end %s\n",
//  				aiProgrCheck[curCheckPoint], a_i, curCheckPoint,
//  				coef, timer.elapsed(), iCur, t1.ascii(), t2.ascii() );
  			if( a_i >= 20 ){
    			setTime( endLabel, newTime );
  			}
			}else{
//  			Log::logMain( 1, "Time: %d\%, pr%d, c%d, %f, elaps%d\n",
//  				aiProgrCheck[curCheckPoint], a_i, curCheckPoint,
//  				coef, timer.elapsed() );
			}
			curCheckPoint++;
		}
		setTime( beginLabel, timer );
	}else{
		curCheckPoint = 0;
		progressBar->reset();
		timer.start();
	}
}

void GBLI::setTime( QLabel *w, QTime &time ){
	int min = time.minute();
	w->setText( QString::number( time.hour() ) +":"+
		(min<10?"0":"")+ QString::number( min ) );
}

// start update
void GBLI::startUpdate()
{
Log::logMain(32,  "GBLI::startUpdate()\n" );
	int res = updatePage->eraseUnselectedRPMS( installselect );
Log::logMain(32,  "GBLI - erase unselected res: %d\n", res );
	int res1 = updatePage->findUpdates( installselect, packageselect );
Log::logMain(32,  "GBLI - found updates res: %d\n", res );
	if( !res && res1 == INST_OK ){
		installselect->changeStage(InstallSelect::initialized);
		installselect->verifyDependencies_();// autosatisfy user selection
    res = installselect->countSelected();
	  QTimer::singleShot( 10, installselect, SLOT( runInstall() ) );
	}else
		QTimer::singleShot( 10, packageselect, SLOT( updateFinished() ) );
}

void GBLI::help(){
/*		QMessageBox::information( this, tr("Help"),
			tr("In SOT we think that good interface does not need help.\n"
				"Please inform us if you know how to improve it's intuitivity.\n"
				"It is our intention to make things perfect."), tr("Ok") );*/
}

// calles when you press Next button on the page
// useful to save some settings from the current page or e.g. start the installation
void GBLI::next(){
#ifndef GBLI_DEVEL
		if( !nextButton()->isEnabled() ) return;
#endif

		QWidget *curpage = currentPage();
		if( !curpage ) return;
		else if( curpage == installselect || curpage == packageselect )
		{
				if( InstallSelect::blUpdate && curpage != packageselect)
				{
					Log::closeMain();
					int res = updatePage->findUpdates( installselect );
					if(res == INST_REBUILD_CANCEL)
					{
						showPage(curpage);
	        	printf("INST_REBUILD_CANCEL: %d\n", res);
					}
					else if(res == INST_REBUILD_FAILED)
					{
						InstallSelect::blUpdateNP = true;
						InstallSelect::blUpdate = false;
						showPage(target);
	        	printf("INST_REBUILD_FAILED: %d\n", res);
					}
					else if(res == INST_WRONG_VERSION)
					{
						showPage(target);
	        	printf("INST_WRONG_VERSION: %d\n", res);
					}

					if(res != INST_OK)
						return;

					installselect->verifyDependencies_();

// packages which were left unselected after findUpdates and verifyDependencies_ are not required
// for update and shouldn't be mustBe
					updatePage->notMustBe(installselect);

        	printf("res after findUpdates() and verifyDependencies(): %d\n", res);
				}
	
  		if(curpage == packageselect || !installselect->isCustom())
			{
				installGoing = true;
				target->setStatus( GBLIPage::Disabled );
				installselect->setStatus( GBLIPage::Disabled );
				packageselect->setStatus( GBLIPage::Disabled );

				if(InstallSelect::blUpdate)
				{
          net->readConfig(NEWROOT);
			    createusers->setStatus( GBLIPage::Disabled );
				}

				// start install or update
		 	  QTimer::singleShot( 1000, installselect, SLOT(runInstall()) );

				if( grub ) grub->init();
			}
		}else if( curpage == target ){
			if( ((Target*)curpage)->selected() == Target::Update )
				installselect->setSelected( InstallSelect::update );
			else
				installselect->setSelected( InstallSelect::full );

			QTimer::singleShot( 2000, this, SLOT( getWindowsSettings() ) );
//			QTimer::singleShot( 500, timezone, SLOT(prepare()) );
		}

		// hack
  	if( curpage->inherits("GBLIPage") )
  		((GBLIPage*)curpage)->setStatus( GBLIPage::Good );
		// hack

    QWizard::next();
}

void GBLI::getWindowsSettings(){
	if( gotWindowsSettings ) return;
	gotWindowsSettings = true;
	Log::logMain( 34, "Get windows settings\n" );
 	WindowsConfig *wcfg = new WindowsConfig( "/tmp/linux.cfg" );
 	if( wcfg->getNetworkSettings( net->getNetinfo() ) ){
 		net->updateWidgets();
 		net->setStatus( GBLIPage::Good );
 	}
	if(!InstallSelect::blUpdate)
	 	createusers->setUserLogin( wcfg->getUserName() );
 	if( wcfg->getModemSettings( modem ) ){
		modem->setStatus( GBLIPage::Good );
 	}
 	monitor->setMode( 0 );
 	if( wcfg->getMonitorSettings( monitor ) )
 		monitor->setStatus( GBLIPage::Good );
 	wcfg->getISPEntrys( ISP );
	if( wcfg->getPrinterSettings( prncfg ) )
		prncfg->setStatus( GBLIPage::Good );
}


void GBLI::back(){
#ifndef GBLI_DEVEL
		if( !backButton()->isEnabled() ) return;
#endif
//    if ( d->current && d->current->back )
//			showPage( d->current->back );

    int i = 0;
    while( i < (int)d->pages.size() && d->pages[i] &&
			d->current && d->pages[i]->w != d->current->w )
			i++;
		--i;
//printf( "i: %d\n", i );
    while( i >= 0 &&
			( !d->pages[i] || !appropriate( d->pages[i]->w ) ) )
				i--;
//printf( "i: %d\n", i );
    // if we fell of the end of the world, step back
    while( i < (int)d->pages.size() && !d->pages[i] )
			i++;
//printf( "i: %d\n", i );
    if ( d->pages.at( i ) ) {
//			d->pages[i]->back = d->current ? d->current->w : 0;
			showPage( d->pages[i]->w );
    }
}


void GBLI::layOutButtonRow( QHBoxLayout * l ){
//printf( "layout buttons\n" );
#ifndef GBLI_STANDALONE
		QLabel *lab = new QLabel( this );
		lab->setAutoMask( true );
		lab->setFixedSize( 47, 10 );
		l->addWidget( lab );
#else
		l->addSpacing( 15 );
    l->addWidget( cancelButton() );
#endif
		l->addStretch( 1 );
    l->addWidget( backButton() );
    l->addWidget( nextButton() );
		l->addStretch( 1 );
		finishStub = new QLabel( this );
		finishStub->setFixedSize( 32, 10 );
		l->addWidget( finishStub );
		finishStub->setAutoMask( true );
    l->addWidget( finishButton() );
		l->addSpacing( 15 );
}

void GBLI::layOutTitleRow( QHBoxLayout * layout, const QString & title ){
//printf( "layout title\n" );
    titleLabel->setText( title );
		layout->addStretch( 1 );
    layout->addWidget( titleLabel, 1 );
		layout->addStretch( 1 );
}

void GBLI::addPage( QWidget *page, const QString &name ){
	addPage( page, name, "" );
}

// adds a page to all needed places, creates an icon and connects it
// with the page
void GBLI::addPage( QWidget *page, const QString &name, const QString &icon_name ){
//	QColor gray = Qt::lightGray;
//	page->setBackgroundColor( QColor(gray.red()+2, gray.green()+2, gray.blue()+2) );

	if( icon_name && icon_name.length() ){
  	StepLabel *lab = lblSteps[ icon_name ];
    if( !lab && StepLabel::available( icon_name ) ){
    	lab = new StepLabel( this, page, icon_name, GBLIPage::Bad );
			lab->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
			connect( lab, SIGNAL(pressed(QWidget *,const QString&)), this, SLOT(changePage(QWidget *,const QString&)) );
    	lblSteps.insert( icon_name, lab );
			lblStepsList.append( lab );
			//Manual page dependant code
			if (name!="While SOT Linux is being installed...")
			{
				QToolTip::add( lab, name );
			}
			else
			{
				QToolTip::add(lab,"Help");
			}

//printf( "Added icon!\n" );
    }
		if( lab && page->inherits("GBLIPage") ){
			connect( page, SIGNAL( statusChanged( int /*GBLIPage::Status*/ ) ),
				lab, SLOT( setStatus( int /*GBLIPage::Status*/ ) ) );
			((GBLIPage*)page)->setStepLabel( lab );
//			lab->hide();
		}else	if( lab ){
			Log::logMain(32, "Bad page: %s\n", name.ascii() );
		}else
			Log::logMain(32, "No icon file found for page: %s\n", name.ascii() );
  }else
		Log::logMain(32, "No icon specified for page: %s\n", name.ascii() );

	page->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
//	page->setAutoMask( true );

	QWizard::addPage( page, name );
}

// switch the page
// checks if it is possible, since it is restricted to pass pages in forward direction
void GBLI::changePage( QWidget *icon, const QString &icon_name ){
  	StepLabel *lab = lblSteps[ icon_name ];
		bool ok = false;
		if( lab ){
			QWidget *page = lab->getPage();
			ok = page != d->current->w;
//			if( ok )
//				ok = timezone != d->current->w;
			if( ok )
				ok = !installGoing ||
					 (page != packageselect && page != diskpartitioner &&
						page != disksel && page != partitionselRoot &&
						page != partitionInfo && page != installselect);
			if( ok )
				ok = lab->getStatus() != GBLIPage::Disabled;
			if( ok ){
				ok = lab->getVisited();
				if( !ok ){
					ok = d->current->nextEnabled;
					if( ok ){
						ok = d->pages[ d->pages.find( d->current )+1 ] == d->page( page );
					}
				}
			}
			if( ok ){
				if( page == installselect ){
					if( partitionInfo && !InstallSelect::blUpdate ){
						partitionInfo->setDone();
#ifndef GBLI_DEVEL
				    partitionInfo->doMounting();
#endif
					}
				}else if( page == finalpage ){
					QString ind;
	      	if( d->current->w->inherits("GBLIPage") )
						ind = ((GBLIPage*)d->current->w)->getHelpName();
					/*debug by dk*/
					//printf("%s \n",ind.ascii());
					/*dk*/
					if( !ind.length() ) ind = "index.html";
					finalpage->setDocument( ind );
       		checkStates();
				}
#ifdef GBLI_STANDALONE
				else if(page == packageselect)
				{
					if(InstallSelect::blUpdate)
					{
						bool blshow = packageselect->findInstallSource() == INST_OK;
						if(!blshow)
							lab->setVisited(false);
					}
				}
#endif
    		// hack
      	if( d->current->w->inherits("GBLIPage") )
				{
#ifndef GBLI_STANDALONE
					((GBLIPage*)d->current->w)->setStatus( GBLIPage::Good );
#else
					if(((GBLIPage*)d->current->w) == packageselect)
					{
						if(!InstallSelect::blUpdateNP)
							((GBLIPage*)d->current->w)->setStatus( GBLIPage::Good );
					}
					else
						((GBLIPage*)d->current->w)->setStatus( GBLIPage::Good );
#endif
				}

#ifdef GBLI_DEVEL
				finishStub->hide();
				finishButton()->show();
				finishButton()->setEnabled( true );
				installFinished = true;
				allFinished = true;
#endif

				QWizard::showPage( page );
				lab->setCurrent( true );
			}
		}
}

// draw the icons ring
// should be rewritten to utilize sin and cos to draw the circle
void GBLI::layOutIcons(){
//printf( "layout icons\n" );
// wdgPageHolder->setBackgroundColor( QColor(80, 200, 80) );
		if( !currentPage() ) return;
//printf( "name: %d, %s\n", currentPage(), currentPage()->name() );
		char current[32];
		strcpy( current, currentPage()->name() );

		int i = 0;
		int iMax = lblSteps.count();
		if( !iMax ){
			penguinLabel->hide();
			return;
		}
		int x, y;
		int ylow = 100;
		int border = 1;
		int height = 480;
		int width = 640;
		int size = 40;
		int backs = iMax / 3;
		if( !backs ) backs = 1;
		int center = iMax / 2;
		int backcenter = backs / 2;
		if( !backcenter ) backcenter = 1;
		int yspace = (height - ylow - border - size) / backs;
		int xspace = size*2;
		if( iMax - backs * 2 )
			xspace = ( width - border*2 - size*2 ) / ( iMax - backs * 2 ) - 11;
		int rightSide = 0;

		bool foundCurrent = false;

		StepLabel *it;
		for ( it=lblStepsList.first(); it != 0; it=lblStepsList.next() ){
			if( i < backs ){ // left
				y = height - yspace*i - ylow - yspace/2 + 7;
if( backs == 1 ) y = 200;
				if( y <= 0 ) y = border;
				int diff = backcenter - i;
				x = border + abs(diff)*8 + i*3;
			}else if( i >= (iMax-backs) ){ // right
// 				rightSide = 30; // penguin
				rightSide = 1; // arrow_hand
				y = yspace*(i - (iMax-backs)) + yspace + 10 /*20*/;
if( backs == 1 ) y = 200;
				int diff = iMax - i - 1 - backcenter;
				x = width - border - size - abs(diff)*8 - (iMax-i-1)*3;
			}else{ // upper
				int even = !((iMax - backs*2) % 2);
				int diff = center - i;
				if( diff > 0 && even ) diff--;
				y = border + abs(diff)*10 + (abs(diff)==1?-1:3);
				x = xspace*(i-backs) + xspace/2 + 50;
			}
//printf( "%d: %d - %d\n", i, x, y );
			if( !strcmp( it->getPage()->name(), "manual" ) )
				it->setVisited( true );
			else if( strcmp( current, "manual" ) )
	      it->setVisited( !foundCurrent );
			if( !foundCurrent ){
				foundCurrent = !strcmp( it->getPage()->name(), current );
				it->setCurrent( foundCurrent );
				if( foundCurrent ){
  	  		penguinLabel->move( x+18-rightSide, y+20 );
					penguinLabel->raise();
				}
			}else
				it->setCurrent( false );
			it->move( x, y );
//printf( "%d\n", it->width() );
//it->show();
			++i;
    }
}

// overriden from hacked QWizard
void GBLI::layOut(){
    bool hasHelp = FALSE;
    bool hasEarlyFinish = FALSE;

    int i = d->pages.size() - 2;
    while ( !hasEarlyFinish && i >= 0 ) {
    	if ( d->pages[i] && d->pages[i]->finishEnabled )
    	    hasEarlyFinish = TRUE;
    	i--;
    }
    i = 0;
    while ( !hasHelp && i < (int)d->pages.size() ) {
    	if ( d->pages[i] && d->pages[i]->helpEnabled )
    	    hasHelp = TRUE;
    	i++;
    }

   	d->finishButton->setEnabled( allFinished );
		layOutIcons();

    if ( hasEarlyFinish ){
//    	d->nextButton->show();
//    	d->finishButton->show();
    	d->nextButton->setEnabled( true );
    } else if ( d->pages.size() == 0 ||
    		d->current->finishEnabled ||
    		d->current == d->pages[d->pages.size()-1] ) {
//    	d->nextButton->hide();
//    	d->finishButton->show();
    	d->nextButton->setEnabled( false );
    } else {
//    	d->nextButton->show();
//    	d->finishButton->hide();
    	d->nextButton->setEnabled( true );
    }

    if ( !d->current )
			return;

    setBackEnabled( d->current->backEnabled /*&& d->current->back != 0*/ );
    setNextEnabled( d->current->nextEnabled );

		titleLabel->setText( d->current ? d->current->t : QString::null );

#ifdef GBLI_STANDALONE
//		nextButton()->hide();
//		backButton()->hide();
//		penguinLabel->hide();

		finishStub->hide();
		finishButton()->show();
		finishButton()->setEnabled( true );
		installFinished = true;
		allFinished = true;
#endif

}

// layOut is called on every repaint, but this one is called in the beginning
// to create layouts
void GBLI::layOutInit(){
//printf( "in layout init\n" );

		d->current = d->page( mouse );
		d->ws->raiseWidget( mouse );

    delete d->v;
    d->v = new QVBoxLayout( this, 3, 0, "top-level layout" );

		d->v->addSpacing( ICONS_BORDER + 12 );
		
    QHBoxLayout * lh1 = new QHBoxLayout();
    d->v->addLayout( lh1, 0 );
    layOutTitleRow( lh1, d->current ? d->current->t : QString::null );
//#else
//		titleLabel->hide();
//#endif

    QHBoxLayout * lh2 = new QHBoxLayout( 0 );
    d->v->addLayout( lh2, 10 );
		lh2->addSpacing( ICONS_BORDER * 3 / 2 + 10 );
		d->ws->setMinimumSize( 50, 50 );
		d->ws->setMaximumSize( 560, 420 );
		lh2->addWidget( d->ws, 1 );
		lh2->addSpacing( ICONS_BORDER * 3 / 2 + 10 );

		d->v->addSpacing( 4 );

    QHBoxLayout * lh3 = new QHBoxLayout( 10 );
    d->v->addLayout( lh3 );
    layOutButtonRow( lh3 );

    d->v->addSpacing( 4 );

    QHBoxLayout * lh4 = new QHBoxLayout( 4 );
    d->v->addLayout( lh4 );
		QLabel *lab = new QLabel( this, "" );
		lab->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );
		lab->setFixedSize( 3, PROGRESS_HEIGHT+1 );
		lh4->addWidget( lab, 0 );
    lh4->addWidget( beginLabel, 0 );
		progressBar->setMaximumWidth( 600 );
    lh4->addWidget( progressBar, 1 );
    lh4->addWidget( endLabel, 0 );
		lh4->addSpacing( 3 );

		layOutIcons();

    d->v->activate();
}

//void GBLI::showPage( QWidget * page )
//{
//    QWizardPrivate::Page * p = d->page( page );
//    if ( p ) {
//			setBackEnabled( p->back != 0 );
//			setNextEnabled( true );
//			d->ws->raiseWidget( page );
//			d->current = p;
//    }
//
//printf( "lets layout\n" );
//    layOut();
//printf( "after layout\n" );
////    updateButtons();
//    emit selected( p ? p->t : QString::null );
//}

// slot which is called by installselect
void GBLI::packageInstallationFinished(){
	installFinished = true;
#ifdef GBLI_DEVEL
  QTimer::singleShot( 60000, this, SLOT(checkStates()) );
#else
	checkStates();
#endif
	QString msg1, msg2;
	if( InstallSelect::blUpdate )
	{
		msg1 = QString(tr( "Update of packages is complete.\n"
						      "Do you want to finish the SOT Linux update?"));
		
		msg2 = QString(tr( "Update of packages is complete.\n"
								      "You can continue configuring SOT Linux\n"
								      "and then complete the update by clicking\n"
								      "the button at the lower right of your screen." ));
	}
	else
	{
		msg1 = QString(tr("Installation of packages is complete.\n"
						      "Do you want to finish the SOT Linux installation?"));

		msg2 = QString(tr( "Installation of packages is complete.\n"
								      "You can continue configuring SOT Linux\n"
								      "and then complete the installation by clicking\n"
								      "the button at the lower right of your screen." ));
	}

	if( allFinished ){
  	int res = QMessageBox::information( this, tr( "Complete" ), msg1,
  	  QMessageBox::Yes, QMessageBox::No );
		if( res == QMessageBox::Yes )
			QTimer::singleShot( 20, this, SLOT(accept()) );
	}else{
  	QMessageBox::information( this, tr( "Complete" ), msg2, QMessageBox::Ok );
	}

}

// chacks that every page is passed
bool GBLI::checkStates(){
	if( !installFinished ) return false;
	if( allFinished ) return true;

	StepLabel *it;
	bool finished = true;
	for ( it=lblStepsList.first(); it != 0; it=lblStepsList.next() ){
		if( it->getStatus() == GBLIPage::Bad || !it->getVisited() ){
			finished = false;
			break;
		}
	}
	if( finished ){
		finishStub->hide();
		finishButton()->show();
		finishButton()->setEnabled( true );
	}

	allFinished = finished;
	return finished;
}

// finish pages and close the installer
void GBLI::accept(){
	Log::logMain( 32, "accept\n" );

	if( installselect->isRunning() ){
	 	int res = QMessageBox::warning( this, tr( "Update is not complete" ),
			tr( "Updating of packages is not finished yet.\n"
					"It is not safe to quit the program at this moment!\n"
					"Do you still want to quit?" ),
					QMessageBox::Yes, QMessageBox::No );
		if( res != QMessageBox::Yes )	return;
	}

#ifdef GBLI_STANDALONE
		net->updateInfo();
    net->save(	NEWROOT.latin1(),
// TODO here: may be we need to read current user name from the running system
// I don't remember how it is used and is it really needed, Maddy 06.06.2001
			"unknown_user" /*createusers->userLogin()*/ );

		Log::logMain( 32, "written net config" );
		::sync();
#ifndef GBLI_DEVEL
		system("depmod -aq >/dev/null 2>&1");
		system("/etc/init.d/network restart >/dev/null 2>&1");
		system("/etc/init.d/network reload >/dev/null 2>&1");
#endif
		setResult( 128 );
		hide();
		qApp->exit( 128 );
		return;
#endif

#ifdef GBLI_DEVEL
  EtcFiles etc( "tere" );
  etc.writeX4Config( NEWROOT +"/etc", videoCard, monitor, videoMode,
	      mouse, keyboard );

		QString user( "tere" );
    etc.writePasswds( user, QString( "test1" ), QString( "test2" ) );

    prncfg->finish();

//    net->save( NEWROOT.ascii() , InstallSelect::blUpdate ? QString("unknown_user") : createusers->userLogin() );
    net->save( NEWROOT.ascii() , createusers->userLogin());

    videoCard->finish();
Log::logMain( 32, "written videoCard config" );	

		::sleep( 1 );
    ::sync();
		QMessageBox::information( this, tr( "Complete" ),
      "Test install finished!",
		  QMessageBox::Ok );

	setResult( 128 );
	hide();
	qApp->exit( 128 );
	return;
#else
	 EtcFiles etc(InstallSelect::blUpdate ? QString("unknown_user") : createusers->userLogin());
#endif
//system( ("lsof >> "+ NEWROOT +"/tmp/lsof1.log").latin1() );

// Hack for live-CD
#ifdef LIVE_CD
    QFile tryFile( INSTALL_SOURCE +"/software/RPMS.BL/XFree86-4.0.2-0.2.i386.rpm" );
    if( !tryFile.exists() ) // live, may be failing dependencies
      system( ("rpm -Uvh --force --nodeps --root "+ NEWROOT +" "+ INSTALL_SOURCE +"/software/RPMS.BL/*.rpm").latin1() );
#endif

  	qApp->setOverrideCursor( Qt::waitCursor );

#ifndef GBLI_DEVEL
    system( "killall -9 xterm" );
    system( "killall -9 realplay" ); // ;-(   ;-)
#endif
    ::sync();
      	
		if(InstallSelect::blUpdate == false)
		{
			Log::logMain( 32, "etc.writePasswds" );
  	  etc.writePasswds(createusers->userName(), createusers->userPassword(), createusers->password());
		}
		if( installselect->withX )
		{
      etc.writeXConfig( NEWROOT +"/etc", videoCard, monitor, videoMode,
  		      mouse, keyboard );
      etc.writeX4Config( NEWROOT +"/etc", videoCard, monitor, videoMode,
  		      mouse, keyboard );
Log::logMain( 32, "written X config" );
	    videoCard->finish();
Log::logMain( 32, "written videoCard config" );	
			etc.writeUserConfig();
Log::logMain( 32, "written User config" );
	    etc.configureFonts();
Log::logMain( 32, "written fonts configuration" );
	    sound->finish();
Log::logMain( 32, "written sound config" );
		}

	    prncfg->finish();
Log::logMain( 32, "written printer config" );

		if( QFile( NEWROOT +"/tmp/devfsd.conf" ).exists() )
			system( ("cat "+ NEWROOT +"/tmp/devfsd.conf >> "+ NEWROOT +"/etc/devfsd.conf").latin1() );
		
		etc.writeEtcConfig();
Log::logMain( 32, "written Etc config" );		

		mouse->finish();
Log::logMain( 32, "written mouse config" );
		
    Language::finish();
Log::logMain( 32, "written locale config" );

		modulessetup->finish();
Log::logMain( 32, "written modules config" );

    // Save all network data
	    net->save( NEWROOT.ascii() , InstallSelect::blUpdate ? QString("unknown_user") : createusers->userLogin());
//    net->save( NEWROOT.ascii() , createusers->userLogin());

Log::logMain( 32, "written net config" );

//system( ("lsof >> "+ NEWROOT +"/tmp/lsof2.log").ascii() );

    // chmod the swap spaces
    QStringList::Iterator dev;
    if( Swapper::swap_devices() ){
      for( dev=Swapper::swap_devices()->begin(); dev != Swapper::swap_devices()->end(); ++dev ) {
				::chmod( (NEWROOT + *dev).ascii(), 0600 );
      }
		}
    system( ("touch "+ NEWROOT +"/etc/mtab").ascii() );
Log::logMain( 32, "chmod swap devices" );

		keyboard->finish();
Log::logMain( 32, "written keyboard config" );
				
//system( ("lsof >> "+ NEWROOT +"/tmp/lsof3.log").ascii() );

    grub->finish( installselect->withX );
Log::logMain( 32, "written grub config" );
		
//system( ("lsof >> "+ NEWROOT +"/tmp/lsof4.log").ascii() );

    modem->finish();
Log::logMain( 32, "written modem config" );

    ISP->finish( createusers->userLogin() );
Log::logMain( 32, "written ISP config")    ;

		system( ("cp -af /etc/sysconfig/clock "+ NEWROOT +"/etc/sysconfig/clock").ascii() );
		if( QFile( "/etc/localtime.real" ).exists() )
			system( ("cp -af /etc/localtime.real "+ NEWROOT +"/etc/localtime").latin1() );
		else
			system( ("cp -af /etc/localtime "+ NEWROOT +"/etc/").latin1() );
Log::logMain( 32, "written timezone config" );

#ifndef GBLI_STANDALONE
	 if (QFile("/etc/sysconfig/hwconf").exists())
			system("cp -af /etc/sysconfig/hwconf "+NEWROOT+"/etc/sysconfig/");
Log::logMain( 32, "written DB of kudzu" );
#endif

#ifdef GBLI_SERVER
		services->finish();
Log::logMain( 32, "written services config" );
#endif


#ifndef GBLI_SERVER

	char mode = 'a';
	FILE* ptFile = fopen(NEWROOT +"/etc/rc.sysinit", &mode);

  if (ptFile != NULL )
	{
		fputs ("\n if [ -f /sbin/iptables ]; then", ptFile); //Added by dk
    fputs ("\n/sbin/iptables -A INPUT -p tcp --syn -j DROP", ptFile);
		fputs ("\nfi", ptFile); //Added by dk

	  fclose (ptFile);
	}

#endif // GBLI_SERVER

    ::sync();

		while( qApp->overrideCursor() )
	  	qApp->restoreOverrideCursor();

  	// Now propose to create bootdisk
	  if( grub->createBootdisk( installselect->withX ) == 1 )
      Log::logMain( 32, "passed by boot disk creation" );
    else
      Log::logMain( 32, "created boot disk" );
	
//system( ("lsof >> "+ NEWROOT +"/tmp/lsof_final.log").ascii() );

		etc.writeWindowsBat();
Log::logMain( 32, "written Windows bat file" );

		////This code - should run  after the latest updated of modules.conf
		//this more clear code
//This is also needed for NVidia drivers
		char strCmd[400];
		sprintf(strCmd,"depmod -aq -F /boot/System.map-%s %s",grub->GetYPKernelVer(),grub->GetYPKernelVer());
		int iRet = system( ("chroot "+ NEWROOT +" /bin/sh -c \""+ strCmd+" \"").latin1() );
		Log::logMain( 32, "modules.conf and modules.dep synchronized,return code: %d",iRet );

/******************* HACK_ZONE **********************/
		ConfCleanups(); //cleanups of /etc/profile
	  ::sync();
		//system( ("touch -r /lib/modules/*/modules.dep "+ NEWROOT + CONF_MODULES +" >/dev/null 2>&1").latin1() );
		system( ("touch -r " +NEWROOT+"/lib/modules/*/modules.dep "+ NEWROOT +"/"+CONF_MODULES +" >/dev/null 2>&1").latin1() );
		system( ("cp -a "+ NEWROOT +"/etc/fstab.orig "+ NEWROOT +"/etc/fstab").latin1() );
    ::sync();

//system( "rm -f /sbin/portmap /sbin/insmod /sbin/lp*" );
//system( "cp -a /usr/sbin/fuser /sbin/fuser" );
/******************* HACK_ZONE **********************/
	#ifndef GBLI_DEVEL
	system( ("chmod 600 " + NEWROOT + "/etc/shadow").latin1() );
	#endif  	

    PartitionInfo::unMounting();

//system( "/sbin/fuser -v /mnt/install" );

//printf( "********* unmounted what is possible\n" );

		::sleep( 1 );
    ::sync();
	if(!InstallSelect::blUpdate)
		QMessageBox::information( this, tr( "Complete" ),
      tr( "Congratulations, installation is complete.\n"
      "\n"
      "Remove the boot media and press return to reboot. For information on fixes \n"
      "which are available for this release of SOT Linux, consult the information "
      "\n"
      "available from http://www.sot.fi.\n"
      "\n"
      "Information on configuring your system is available in the\n"
			"\"Advanced Configuration\" chapter of the Original SOT Linux User's Guide." ),
		  QMessageBox::Ok );
	else
		QMessageBox::information( this, tr( "Complete" ),
      tr( "Congratulations, update is complete.\n"
      "\n"
      "Remove the boot media and press return to reboot. For information on fixes \n"
      "which are available for this release of SOT Linux, consult the information "
      "\n"
      "available from http://www.sot.fi.\n"
      "\n"
      "Information on configuring your system is available in the\n"
			"\"Advanced Configuration\" chapter of the Original SOT Linux User's Guide." ),
		  QMessageBox::Ok );

	setResult( 128 );
	hide();

	::sync();

//	system("killall -9 X");
	
	qApp->exit( 128 );
}

// called when user presses 3 magic buttons ;)
void GBLI::reboot()
{
#ifndef GBLI_DEVEL
  QApplication::flushX();
#endif
  if ( QMessageBox::information( installselect, tr( "Control-Alt-Delete" ),
				   tr( "Are you sure you want to reboot?" ),
				   tr( "Reboot." ),
				   tr( "  Continue with install" ).simplifyWhiteSpace(),
				   QString::null,
				 1, 1 ) == 0 ) {
#ifndef GBLI_DEVEL
    ::sync();
    ::reboot(RB_AUTOBOOT);
#endif
  }
}


static int screendumpNumber = 0;

void GBLI::screendump()
{
    QPixmap p = QPixmap::grabWindow( topLevelWidget()->handle(), 0,0,640,480 ); //modified by dk
		//As the GBLI goes in 640x480 resolution (hardcoded) then we just get the solution
		//by telling the grab exact dimensions (dk)
    QString name;
    if( QFile( NEWROOT +"/tmp" ).exists() )
      name.sprintf( "%s/tmp/gbli%02d.png", NEWROOT.latin1(), ++screendumpNumber );
    else
      name.sprintf( "/tmp/gbli%02d.png", ++screendumpNumber );
    p.save( name, "PNG" );
}


void GBLI::keyPressEvent(QKeyEvent *e)
{
  if( e->key() == Key_Escape ){
    e->accept();
	} else {
    e->ignore();
    QWizard::keyPressEvent( e );
  }
}

void GBLI::xterm(){
  runXProgram( "bash", "/usr/X11R6/bin/xterm", "xterm +cm +dc -T \"bash\" -e /bin/bash", -1 );
}

void GBLI::runXProgram(  const char *a_search, const char *a_prg, const char *a_args, signed int a_iNice ){
  // find an existing window
  unsigned int i, j, nwins, nsubwins;
  Window dw1, dw2, *wins, *subwins;
  XTextProperty attr;
  int count;
  char **list;
 
  XQueryTree(qt_xdisplay(), qt_xrootwin(), &dw1, &dw2, &wins, &nwins);
  for (i = 0; i < nwins; i++) {
    XQueryTree(qt_xdisplay(), wins[i], &dw1, &dw2, &subwins, &nsubwins);
    for (j = 0; j < nsubwins; j++) {
      XGetWMName(qt_xdisplay(), subwins[j], &attr);
      if (XTextPropertyToStringList(&attr, &list, &count)){
    	  if( count > 0 )
    	    if( strcmp(list[0], a_search) == 0 ){
        		XRaiseWindow(qt_xdisplay(), subwins[j]);
        		return;
 	      }
    	  XFreeStringList(list);
    	}
    }
    
    XFree((void *) subwins);
  }
  XFree((void *) wins); 

  // run a new program
  int pid = ::fork();
  if( pid == 0 ){
    ::nice( a_iNice );
    ::execlp( a_prg, a_args, 0 );
    ::exit( 0 );
  }
}

