/***************************************************************************
                                 gblipage.h
                             -------------------                                         
    begin                : Mon Dec 4 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef GBLIPAGE_H
#define GBLIPAGE_H

#include <qwidget.h>

class StepLabel;

/**
  *@author Anton Safonov (Maddy)
  */

// this is common class for all pages in th GBLI
// must be inherited, since it enables adding, managing and interaction
// between pages and icons
// also add to the page such a useful thing as a Status
class GBLIPage : public QWidget  {
   Q_OBJECT
public: 
	GBLIPage( QWidget *parent=0, const char *name=0, WFlags f=0 );

	// enables/disables the page
	// Good - page was visited and configured or autoconfigured
	// Bad - page is not visited or not valid
	// Disabled - user can't visit it, e.g. partitioning after
	// 						installation has already started
	enum Status { Good, Bad, Disabled };
	Status getStatus(){ return status; };
	void setStatus( Status a_status ){
		status = a_status;
		emit statusChanged( status );
	};

	// get/set the icon of this page
	StepLabel *getStepLabel(){ return steplabel; };
	void setStepLabel( StepLabel *a_steplabel );

	// get/set the name of the help page in the manual
	void setHelpName( QString a_name ){ strHelp = a_name; };
	QString& getHelpName(){ return strHelp; };

signals:
	// page signals to the icon and others that Status has changed
	void statusChanged( int /*Status a_status*/ );

public slots:
	// this function must be overriden by descendants and
	// should be called from GBLI::accept() to save the settings
	// to the real hard drive (use NEWROOT as a path)
	virtual void finish() = 0;

private:
	// status of the page
	Status status;

	// icon of the page
	StepLabel *steplabel;

	// help document name
	QString strHelp;

};

#endif
