/***************************************************************************
                          isdnpage.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Jan 12 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "isdnpage.h"
#include "liconloader.h"
#include "log.h"
#include <stdio.h>
#include <ctype.h>
#include <qlayout.h>

ISDNPage::ISDNPage( Netinfo *net, QWidget * parent, const char * name = 0 )
    : QWidget( parent, name ), netinfo( net )
{
	this->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );

  bg = new QButtonGroup( 0 );


  rbISDNDisabled = new QRadioButton( tr( "No ISDN" ), this );
	rbISDNDisabled->setAutoMask(true);
  bg->insert( rbISDNDisabled, 0);
  rbISDNEnabled = new QRadioButton( tr( "ISDN present" ), this );
	rbISDNEnabled->setAutoMask(true);
  bg->insert( rbISDNEnabled, 1);

  leOutPhone = new extLineEdit(this,0,2);

//  connect( leOutPhone, SIGNAL(clicked(int)), this, SLOT(setMode(int)) );

/*	QValidator myValidator = new QValidator(leOutPhone);
	leOutPhone->setValidator(myValidator);
	myValidator->fixup("0123456789");*/
//  leOutPhone->setValidator( new QDoubleValidator( 0, 9999999999, 0, leOutPhone ) );
	leInPhone = new extLineEdit(this,0,2);
	leUser = new extLineEdit(this,0,0); //old this,0,3 not compatible with life :)
	lePass = new extLineEdit(this,0,0); //old this,0,3
	lePass->setEchoMode(QLineEdit::Password);

//  connect( leInPhone, SIGNAL(), this, SLOT(setMode(int)) );

	QLabel *l;
/*#ifndef GBLI_DEVEL
	QGridLayout *grid = new QGridLayout(2,5,5);
	l = new QLabel(tr("Provider phone:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,0,0);
	grid->addWidget(leOutPhone,0,1);
	l = new QLabel(tr("Your phone:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,1,0);
	grid->addWidget(leInPhone,1,1);

	l = new QLabel(tr("Username:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,0,3);
	grid->addWidget(leUser,0,4);
	l = new QLabel(tr("Password:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,1,3);
	grid->addWidget(lePass,1,4);
*/
//#else begin of new code
	QGridLayout *grid = new QGridLayout(4,5,5);
	grid->addMultiCellWidget(rbISDNDisabled,0,0,0,1);
	grid->addMultiCellWidget(rbISDNEnabled,1,1,0,1);
/*
	l = new QLabel(tr("ISDN type: "),this);
	l->setAutoMask(true);
	grid->addWidget(l,0,3,Qt::AlignRight);
	lType = new QLabel( tr("unknown"), this );
	lType->setAutoMask(true);
	grid->addWidget(lType,0,4,Qt::AlignRight);
*/
	QHBoxLayout *HL1 = new QHBoxLayout();
	//HL1->addWidget(rbISDNDisabled);
	l = new QLabel(tr("ISDN type: "),this);
	l->setAutoMask(true);
	HL1->addWidget(l,1,Qt::AlignRight);
	lType = new QLabel( tr("unknown"), this );
	lType->setAutoMask(true);
	HL1->addWidget(lType);

	grid->addLayout(HL1,0,4);

 	btProbe = new QPushButton(tr("Probe"),this);
	grid->addWidget(btProbe,1,4,Qt::AlignRight);

	l = new QLabel(tr("Provider phone:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,0+3,0);
	grid->addWidget(leOutPhone,0+3,1);
	l = new QLabel(tr("Your phone:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,1+3,0);
	grid->addWidget(leInPhone,1+3,1);

	l = new QLabel(tr("Username:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,0+3,3);
	grid->addWidget(leUser,0+3,4);
	l = new QLabel(tr("Password:"),this);
	l->setAutoMask(true);
	grid->addWidget(l,1+3,3);
	grid->addWidget(lePass,1+3,4);

//#endif end of new code

	QHBoxLayout *ML = new QHBoxLayout(this,5);
//	ML->addStretch();
	QVBoxLayout *VL = new QVBoxLayout();
	ML->addLayout(VL);
	ML->addStretch( 1 );

/*#ifndef GBLI_DEVEL
	QHBoxLayout *HL1 = new QHBoxLayout();
	HL1->addWidget(rbISDNDisabled);
	l = new QLabel(tr("ISDN type: "),this);
	l->setAutoMask(true);
	HL1->addWidget(l,1,Qt::AlignRight);
	lType = new QLabel( tr("unknown"), this );
	lType->setAutoMask(true);
	HL1->addWidget(lType);

	QHBoxLayout *HL2 = new QHBoxLayout();
	HL2->addWidget(rbISDNEnabled,1);
	btProbe = new QPushButton(tr("Probe"),this);
	HL2->addWidget(btProbe);
#else
#endif
*/

	connect(btProbe, SIGNAL(clicked()), this, SLOT(probeISDNCard()));


	VL->addSpacing( 3 );
/*#ifndef GBLI_DEVEL
	VL->addLayout(HL1);
	VL->addLayout(HL2);
	VL->addLayout(grid);
#else
#endif
*/
	VL->addLayout(grid);

	VL->addStretch( 1 );

  connect( bg, SIGNAL(clicked(int)), this, SLOT(setMode(int)) );

	//Added by dk
	isdnBoot = new QCheckBox(tr("Enable ISDN on startup"),this);
	isdnBoot->setAutoMask(true);
	QVBoxLayout *HL3 = new QVBoxLayout();
	HL3->addWidget(isdnBoot,1);
	
	VL->addSpacing(3);
	VL->addLayout(HL3);
	VL->addStretch(1);
	connect(isdnBoot, SIGNAL(clicked()), this, SLOT(setBoot()));
	isdnBoot->setChecked(true);
	isdnBoot->setEnabled(false);
	
	setMode(0);	

}

void ISDNPage::updateWidgets()
{
	setMode(netinfo->getISDNMode());
	leUser->setText(netinfo->getISDNUser());
	lePass->setText(netinfo->getISDNPass());
	leInPhone->setText(netinfo->getISDNInPhone());
	leOutPhone->setText(netinfo->getISDNOutPhone());
	lType->setText(netinfo->getISDNType());
	isdnBoot->setChecked(netinfo->getISDNboot());
}

void ISDNPage::updateInfo()
{
  netinfo->setISDNPass(lePass->text(), Netinfo::User);
  netinfo->setISDNUser(leUser->text(), Netinfo::User);
  netinfo->setISDNInPhone(leInPhone->text(), Netinfo::User);
  netinfo->setISDNOutPhone(leOutPhone->text(), Netinfo::User);
	netinfo->setISDNType(lType->text(), Netinfo::User);
	netinfo->setISDNboot(isdnBoot->isChecked());
}

/*void ISDNPage::keyPressEvent( QKeyEvent *k )
{
  switch (k->ascii()) {
    case 'r':
			printf("r pressed\n");
			k->ignore();                               // reload
    break;
    case 'q':                               // quit
//      QApplication::exit();
    break;
	}
} */

void ISDNPage::setBoot() //Added by dk
{
  if (leOutPhone->isEnabled())
		netinfo->ISDNboot=isdnBoot->isChecked();
}


void ISDNPage::setMode(int nm){
QRadioButton *pRadioButton = NULL;
int iNm;

		enableISDN(nm);
		if (nm==Netinfo::NoConfig) iNm = 0;
		else iNm = 1;
	
		if ((pRadioButton = ((QRadioButton*)bg->find(iNm))) !=NULL ){
				bg->setButton( iNm );
				pRadioButton->setFocus();
//  	#ifdef GBLI_DEVEL
//				if (!pRadioButton->hasFocus())
//				perror("ISDN Focus not set!!!!");
//				printf("ISDN::setMode %d\n",nm);
//		#endif
				// it looks, it could be re-set by itself call :)
				// that can be needed ,if reading configuration
		}

}

void ISDNPage::probeISDNCard(){
/*#ifdef GBLI_DEVEL
	lType->setText("TestType");
	enableISDN(1);
	rbISDNEnabled->setChecked(true);
	rbISDNEnabled->setFocus();
	return;
#endif
*/
	Log::logMain(32, "probing...\n");

/////////////////////////////
//lType->setText(tr("15"));
//return;
/////////////////////////////

//	char some;
	int a;
//	int result=system("insmod slhc");
	system("rmmod isdn >>/dev/null"); //Added by dk
	int result=system("modprobe -q isdn");//Added by dk
//	printf("ISDN result: %i\n",result);
	if(result) return;

	char comstr[100];
  FILE *fp;
	char fstr[50];

	// For testing
//	lType->setText("5");
//	return;
	//////////////

	for(a=1;a<40;a++){
//		getchar();
		if(a==10 || a==22 || a==26 || a==39) continue;
		sprintf(comstr,"modprobe -q hisax type=%i >/dev/null",a); //Modified to modprobe by dk
//		printf("%i,\n",a);
		result=system("cp /var/log/messages.kern /var/log/messages.kern.old");
//		printf("Copy result: %i\n", result);
		result=system(comstr);
		if(!result){
//		  printf("\nMaybe it works. Let's check it\n");
			system("diff /var/log/messages.kern /var/log/messages.kern.old | grep \"not installed\" >/tmp/output.txt");
			fp=fopen("/tmp/output.txt","r");
			fstr[0]=0;
			fgets(fstr,50,fp);
			fclose(fp);
			if(strlen(fstr)==0){
//      	printf("YES, it works\n");
				char strType[2];
				sprintf(strType,"%i",a);
				lType->setText(strType);
				
				//Added by dk to reflect result on interface
				enableISDN(1);
       	rbISDNEnabled->setChecked(true);
				system("rmmod hisax");
				system("rmmod isdn");
				return;
			}
			system("rmmod hisax");
    }
	}
	
	lType->setText(tr("not found"));
	system("rmmod isdn");
	Log::logMain(32, "ISDN card not found\n");

}

/*void ISDNPage::keyPressEvent( QKeyEvent *e )
{
	if ( e->key() == Key_A) {
		printf("a key pressed\n");
		e->accept();
	}
	else{
  	e->ignore();
//  	ISDNPage::keyPressEvent( e );
  }
}*/



ISDNPage::~ISDNPage(){
}

void extLineEdit::keyPressEvent(QKeyEvent * k){
//here can be logical mistake
//should be passed some extra symbols like .,-_ and etc
//can be used for login and especially for password

  if( !(k->key()>Key_Escape && k->key()<Key_ScrollLock) )

	switch(FilterType)
	{
		case 0: // No filter
		break;
		case 1: // Only numbers
			if( !isdigit(k->key()) ) return;
		break;
		case 2: // Phone number
			if( !isdigit(k->key()) &&
				k->key()!=Key_Plus && k->key()!=Key_Minus &&
				k->key()!=Key_Comma && k->key()!='(' &&
				k->key()!=')') return;
		break;
		case 3: // Username or password
			if( !isalnum(k->key()) && k->key()!='_' && k->key()!='-') return;
		break;
	}
	QLineEdit::keyPressEvent(k);

}
/**  */
void ISDNPage::enableISDN(int enbl){
	
	leOutPhone->setEnabled(enbl);
	leInPhone->setEnabled(enbl);
	lePass->setEnabled(enbl);
	leUser->setEnabled(enbl);
	netinfo->setISDNMode( (Netinfo::Setup)enbl );
	isdnBoot->setEnabled(enbl);
}
