/***************************************************************************
                          isdnpage.h  -  description                              
                             -------------------                                         
    begin                : Fri Jan 12 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef ISDNPAGE_H
#define ISDNPAGE_H

#include "config.h"

#include "gblipage.h"
#include "network.h"

#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qvbuttongroup.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qwidget.h>
#include <qevent.h>

/**
  *@author Oleg Golovachov ()
  */

class extLineEdit;

class ISDNPage : public QWidget {
    Q_OBJECT
public:
	ISDNPage( Netinfo *, QWidget * parent=0, const char * name = 0 );
	~ISDNPage();

  void updateInfo();
	void updateWidgets();
  /**  */
  void enableISDN(int enbl);

public slots:
	void setMode(int);
	void setBoot();
	
protected slots:
	void probeISDNCard();
//	void keyPressEvent(QKeyEvent *);

/*protected:
  void keyPressEvent( QKeyEvent * );*/


private:
	
	extLineEdit *leOutPhone;
	extLineEdit *leInPhone;
	extLineEdit *leUser;
	extLineEdit *lePass;
	QButtonGroup *bg;
	QLabel *lType;
	QPushButton *btProbe;
	QCheckBox *isdnBoot;
  QRadioButton *rbISDNDisabled, *rbISDNEnabled;

	Netinfo *netinfo;

/*protected:
  void keyPressEvent( QKeyEvent *e );*/

};

class extLineEdit:public QLineEdit{
public:
	extLineEdit(QWidget * parent, const char * name=0, int FilterType=0):
  	QLineEdit(parent, name){this->FilterType=FilterType;}
	virtual void keyPressEvent(QKeyEvent *);
	int FilterType;

};

#endif
