/***************************************************************************
                             languagedialog.cpp
                             -------------------                                         
    begin                : Tue Nov 9 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "languagedialog.h"
#include "config.h"
#include "liconloader.h"

#include <qframe.h>
#include <qtooltip.h>
#include <qfontmetrics.h>

LanguageDialog::LanguageDialog( QWidget *parent, QString name )
: QDialog( parent, name, TRUE )
{

#ifndef GBLI_DEVEL
    static Atom noDecoration = ::XInternAtom( qt_xdisplay(),
					       "KWM_WIN_DECORATION", False );
		long l = 0;
    XChangeProperty(qt_xdisplay(), winId(), noDecoration, noDecoration, 32,
		  PropModeReplace, (unsigned char *)&l, 1);
#endif
	setFocusPolicy( QWidget::StrongFocus );

	this->setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );

	QHBoxLayout *loHBig = new QHBoxLayout( this );
	QVBoxLayout *lo = new QVBoxLayout;
	loHBig->addSpacing( 5 );
	loHBig->addLayout( lo );
	loHBig->addSpacing( 5 );

	QHBoxLayout *layout = new QHBoxLayout;
	lo->addSpacing( 10 );
	lo->addLayout( layout );
	lo->addSpacing( 5 );
	QLabel *titleLabel = new QLabel( "Where are you?", this );
	titleLabel->setAutoMask( true );
	titleLabel->setAlignment(AlignCenter);
	QFont f( "arial", Language::iBigFontSize, QFont::Bold );
  titleLabel->setFont( f );
//  titleLabel->setFont( QFont( "arial", 24 ) );

  QLabel *titleLogo = new QLabel( this );
#ifndef GBLI_SERVER
	titleLogo->setPixmap( LIconLoader::loadIcon("blinstallation2_desktop.gif"));
#else
  titleLogo->setPixmap( LIconLoader::loadIcon("blinstallation2_server.gif"));
#endif	
	titleLogo->setAutoMask( true );

	layout->addSpacing( 20/*17*/ );
  layout->addWidget( titleLogo, 0 );
	layout->addStretch( 15 );
  layout->addWidget( titleLabel, 0 );
	layout->addSpacing( 15 );

 	QFrame *fr = new QFrame(this);
 	fr->setFrameStyle(QFrame::HLine | QFrame::Sunken);
 	lo->addWidget(fr);

	lang = new Language( this );
	lang->setAutoMask( true );
	lo->addWidget( lang );
	connect( lang, SIGNAL( updateTime() ), this, SLOT( setTime() ) );

 	QFrame *fr1 = new QFrame(this);
 	fr1->setFrameStyle(QFrame::HLine | QFrame::Sunken);
 	lo->addWidget(fr1);
	lo->addSpacing( 5 );

	QPushButton *cancel;
	cancel = new QPushButton( tr("Cancel"), this );
	cancel->setPixmap( LIconLoader::loadIcon( "exit.gif" ) );
	QToolTip::add( cancel, tr( "Cancel installation" ) );
	connect( cancel, SIGNAL(clicked()), SLOT(rejectLanguage()) );
	cancel->setFocusPolicy( QWidget::StrongFocus );
	
	QPushButton *ok;
	ok = new QPushButton( tr("Next>>"), this );
  ok->setPixmap( LIconLoader::loadIcon( "next.gif" ) );
	QToolTip::add( ok, tr( "Continue with installation" ) );
	connect( ok, SIGNAL(clicked()), SLOT(chooseLanguage()) );
	ok->setFocusPolicy( QWidget::StrongFocus );

	QHBoxLayout *loH = new QHBoxLayout();

	clock_h = new QLabel( "XX", this );
	clock_h->setAutoMask( true );
	clock_m = new QLabel( "XX", this );
	clock_m->setAutoMask( true );
	loH->addSpacing( 30 );
	loH->addWidget( clock_h, 0 );
	lblBlink = new QLabel( ":", this );
	loH->addSpacing( 2 );
	lblBlink->setFixedWidth( 3 );
	lblBlink->setAutoMask( true );
	loH->addWidget( lblBlink, 0 );
	loH->addSpacing( 2 );
	loH->addWidget( clock_m, 0 );
	loH->addStretch( 20 );
	loH->addWidget( cancel );
	loH->addSpacing( 5 );
	loH->addWidget( ok );
	loH->addSpacing( 50 );
	lo->addLayout( loH );
	lo->addSpacing( 5 );

	blink = new QTimer();
	connect( blink, SIGNAL( timeout() ), this, SLOT( makeBlink() ) );

	updateTime = new QTimer();
	connect( updateTime, SIGNAL( timeout() ), this, SLOT( setTime() ) );

	setTime();
}















