/***************************************************************************
                              languagedialog.h
                             -------------------                                         
    begin                : Tue Nov 9 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "gbli.h"
#include "language.h"

#include <qstring.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qpushbutton.h>

#include <stdlib.h>
#include <sys/timeb.h>

// fake dialog which looks like GBLI (QWizard), contains Language page
class LanguageDialog : public QDialog {
	Q_OBJECT
public:
	LanguageDialog( QWidget *parent = 0, QString name = 0 );


protected:
	void showEvent( QShowEvent * ){ blink->start( 1000 ); updateTime->start( 10000 ); };
	void hideEvent( QShowEvent * ){ blink->stop(); updateTime->stop(); };

protected slots:
	void chooseLanguage(){
//		lang->finishTime(); // strange, but it works wring here, but it
// doesn't affect anything if we switch it off ;)
		lang->hide();
		accept();
 	};

	// create a "flag" so that second stage of the GBLI doesn't start
  void rejectLanguage(){
    system( "touch /tmp/gbli_reboot" );
    reject();
  }

	// blink ":" in the time field
	void makeBlink(){ lblBlink->setText( lblBlink->text()==":"?" ":":" ); };

	void setTime(){
  	struct timeb timestr;
  	ftime( &timestr );
		QTime time = QTime::currentTime();
		clock_h->setText( QString::number( time.hour() ) );
		int min = time.minute();
		QString m = QString::number( min );
		if( min < 10 ) m = "0" + m;
		clock_m->setText( m );
	}

private:
	Language *lang;
	QLabel *clock_h;
	QLabel *clock_m;
	QLabel *lblBlink;
	QTimer *blink;
	QTimer *updateTime;
};

