/***************************************************************************
                               linlinehelp.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "linlinehelp.h"

#include <qaccel.h>

LInlineHelp::LInlineHelp( QWidget *parent, const char *name )
    : QTextBrowser( parent, name)
{
    QFont font( QFont::defaultFont() );
//		font.setFamily( "times" );
		viewport()->setFont( font );
    QColorGroup clgrp = colorGroup();
    clgrp.setColor( QColorGroup::Base, QColor( 255, 255, 224 ) );
    setPaperColorGroup( clgrp );
    setFixedWidth( 196 );
    setFrameStyle( QFrame::Panel | QFrame::Sunken );
    setFocusPolicy( NoFocus );


    QAccel * a1 = new QAccel( this );
    a1->connectItem( a1->insertItem( Qt::Key_Up ),
		    this, SLOT(keyUp()) );
    a1->connectItem( a1->insertItem( Qt::Key_Down ),
		    this, SLOT(keyDown()) );
    a1->connectItem( a1->insertItem( Qt::Key_PageDown ),
		    this, SLOT(keyPgDown()) );
    a1->connectItem( a1->insertItem( Qt::Key_PageUp ),
		    this, SLOT(keyPgUp()) );
    a1->connectItem( a1->insertItem( Qt::Key_Home ),
		    this, SLOT(keyHome()) );
    a1->connectItem( a1->insertItem( Qt::Key_BackSpace ),
		    this, SLOT(keyBack()) );
    a1->connectItem( a1->insertItem( Qt::Key_Insert ),
		    this, SLOT(keyForward()) );
}

LInlineHelp::~LInlineHelp()
{
}

void LInlineHelp::setDocument(const QString& name){
    documentName = name;
    setSource( name );
}


void LInlineHelp::languageChanged()
{
  QTextBrowser::setSource( documentName );
}

LLabel::LLabel( const QString& title, QWidget *parent, const char *name )
    : QLabel( parent, name)
{
    contents = title;
		setFontPropagation( QWidget::AllChildren );
    setFont( QFont::defaultFont() );
    doc = new QSimpleRichText(contents, QFont::defaultFont() );
}

LLabel::~LLabel()
{
	delete doc;
}

int LLabel::heightForWidth( int w ) const
{
    QSimpleRichText tdoc(contents, QFont::defaultFont() );
    {
			QPainter p( this );
			tdoc.setWidth(&p, w);
    }
    return tdoc.height();

}

void LLabel::drawContents( QPainter * p)
{
    doc->setWidth(p, contentsRect().width() );
    doc->draw(p, contentsRect().x(), contentsRect().y(), contentsRect(), colorGroup(), 0);
}

LInlineTitle::LInlineTitle( const QString& title, QWidget *parent, const char *name )
    : LLabel( title, parent, name)
{
}

LInlineTitle::~LInlineTitle()
{
}


void LLabel::setContents( const QString& txt )
{

    if ( contents == txt )
			return;
    contents = txt;
    repaint();
}






