/***************************************************************************
                            linlinehelp.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		 : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			 : http://www.bestlinux.net
    email		 : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LINLINEHELP_H
#define LINLINEHELP_H

#include <stdio.h>
#include <qtextbrowser.h>
#include <qsimplerichtext.h>
#include <qlabel.h>
#include <qevent.h>

class LInlineHelp : public QTextBrowser{
    Q_OBJECT
public:
    LInlineHelp( QWidget *parent=0, const char *name=0 );
    ~LInlineHelp();

    void setDocument(const QString& name);

private slots:
		// enable key scrolling of the manual or any help
		void keyHome(){ if( isVisible() ) home(); };
		void keyBack(){ if( isVisible() ) backward(); };
		void keyForward(){ if( isVisible() ) forward(); };
		void keyDown(){ if( isVisible() ) scrollBy( 0, 14 ); };
		void keyUp(){ if( isVisible() ) scrollBy( 0, -14 ); };
		void keyPgDown(){ if( isVisible() ) scrollBy( 0, 280 ); };
		void keyPgUp(){ if( isVisible() ) scrollBy( 0, -280 ); };

    void languageChanged();

private:
    QString documentName;
};


class LLabel : public QLabel
{
    Q_OBJECT
public:
    LLabel( const QString& txt, QWidget *parent=0, const char *name=0 );
    ~LLabel();
    int heightForWidth( int w ) const;

    void setContents( const QString& txt );

protected:
    void drawContents( QPainter * );

private:
    QSimpleRichText* doc;
    QString contents;
};


class LInlineTitle : public LLabel
{
    Q_OBJECT
public:
    LInlineTitle( const QString& title, QWidget *parent=0, const char *name=0 );
    ~LInlineTitle();
};




#endif

