/****************************************************************************
**
** $Id: lispdata.h,v 1.4 2000/01/20 15:18:49 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#ifndef __L_ISP_DATA__
#define __L_ISP_DATA__


#include <qstring.h>
#include <qstringlist.h>


class LISP
{
public:

  LISP();

  QStringList category() { return _category; };
  void setCategory(QStringList c) { _category = c; };

  QString name() { return _name; };
  void setName(QString n) { _name = n; };
  
  QString phone() { return _phone; };
  void setPhone(QString p) { _phone = p; };

  QString DNS1() { return _dns1; };
  void setDNS1(QString d) { _dns1 = d; };

  QString DNS2() { return _dns2; };
  void setDNS2(QString d) { _dns2 = d; };

  QString proxy() { return _proxy; };
  void setProxy(QString p) { _proxy = p; };

  QString mail() { return _mail; };
  void setMail(QString m) { _mail = m; };

  bool PPP() { return _ppp; };
  void setPPP(bool p) { _ppp = p; };

  bool callByCall() { return _call; };
  void setCallByCall(bool c) { _call = c; };

  QString user() { return _user; };
  void setUser(QString u) { _user = u; };
  
  QString password() { return _password; };
  void setPassword(QString p) { _password = p; };


private:

  QStringList _category;
  QString     _name;
  QString     _phone;
  QString     _dns1, _dns2;
  QString     _proxy, _mail;
  bool        _ppp, _call;
  QString     _user, _password;

};


class LISPData : public LISP
{ 
public:

  LISPData() : LISP(), _savePasswd(false), _hasProv(false) {};

  static LISPData *data();

  bool savePassword() { return _savePasswd; };
  void setSavePassword(bool sp) { _savePasswd = sp; };

  bool hasProvider() { return _hasProv; };
  void setHasProvider(bool hp) { _hasProv = hp; };
  

private:

  static LISPData *_data;

  bool _savePasswd;
  bool _hasProv;

};


#endif
