/****************************************************************************
**
** $Id: lispdetails.cpp,v 1.4 2000/02/15 10:00:21 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qframe.h>
#include <qfont.h>
#include <qpushbutton.h>


#include "llog.h"
//#include "lconfig.h"
#include "lglobal.h"


#include "lispdetails.h"
#include "lispdetails.moc"


LISPDetails::LISPDetails(QWidget *parent)
  : QDialog(parent,0,true)
{
//	setFont( QFont::defaultFont() QApplication::font());
	setFont( QApplication::font());
  setBackgroundPixmap( LIconLoader::loadIcon( TEXTURE ) );

  QVBoxLayout *vbox = new QVBoxLayout(this, 6,6);

  QGridLayout *grid = new QGridLayout(vbox, 2,2);

  name = new QLineEdit(this);
  grid->addWidget(name, 0,1);
  QLabel *l = new QLabel(name, tr("&Name"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 0,0);

  phone = new QLineEdit(this);
  grid->addWidget(phone, 1,1);
  l = new QLabel(phone, tr("&Phone"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 1,0);

  dns1 = new AddressEdit(AddressEdit::Address, this);
  grid->addWidget(dns1, 2,1, AlignLeft);
  l = new QLabel(dns1, tr("&DNS-Server"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 2,0);

  dns2 = new AddressEdit(AddressEdit::Address, this);
  grid->addWidget(dns2, 3,1, AlignLeft);
  l = new QLabel(dns2, tr("&Secondary DNS"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 3,0);

  mail = new QLineEdit(this);
  grid->addWidget(mail, 4,1);
  l = new QLabel(mail, tr("&Mail"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 4,0);
  mail->hide(); l->hide();

  proxy = new QLineEdit(this);
  grid->addWidget(proxy, 5,1);
  l = new QLabel(proxy, tr("P&roxy"),this);
	l->setAutoMask(true);
  grid->addWidget(l, 5,0);
  proxy->hide(); l->hide();

  ppp = new QCheckBox(tr("Sp&eaks PPP natively"),this);
	l->setAutoMask(true);
  grid->addWidget(ppp, 6,1);
  ppp->hide();

  QFrame *f = new QFrame(this);
  f->setFrameStyle(QFrame::Sunken | QFrame::HLine);
  grid->addMultiCellWidget(f, 7,7, 0,1);

  QHBoxLayout *box = new QHBoxLayout(vbox, 6);
  box->addStretch();
  QPushButton *ok, *cancel;
  ok = new QPushButton( tr("&Ok"), this );
  box->addWidget(ok);
  connect( ok, SIGNAL(clicked()), SLOT(accept()) );
  cancel = new QPushButton( tr("&Cancel"), this );
  box->addWidget(cancel);
  connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
  
}


