/****************************************************************************
**
** $Id: llog.cpp,v 1.3 1999/12/30 14:49:52 mm Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#include <time.h>
#include <fstream.h>
#include <ostream.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>


#include "llog.h"


// default target is standard error
ostream *LLog::_output = &cerr;
char *LLog::_filename = 0;


LLog::LLog()
{
}


char buffer[128];

char *now()
{
  time_t t = time(0);
  struct tm *tmp = gmtime(&t);

  strftime(buffer, 128, "(%d.%m.%Y %T) ", tmp);

  return buffer;
}


ostream &LLog::log(const char *tag)
{
  output() << now() << tag << ": ";
  return output();
}


void LLog::setTarget(const char *target)
{
  // remove the target file, if an old one is lying around
  ::unlink(target);

  if (_filename)
    {
      // flush stream
      _output->flush();

      // copy existing file over
      ifstream old_file(_filename);
      ofstream new_file(target);
      if (old_file && new_file)
	{
	  char c;
	  while (old_file.get(c)) 
	    new_file.put(c);
	}

      // delete old output stream & filename
      delete _output;
      free(_filename);
    }

  ofstream *_xoutput = new ofstream(target, ofstream::app);
//  _xoutput->setbuf(NULL,0); // TODO: doesn't work with gcc-3
  // try to open new output
  _output = _xoutput;
  _filename = strdup(target);

  // fall back to standard error
  if (!_output)
    {
      _output = &cerr;
      _filename = 0;
    }
}
