/****************************************************************************
**
** $Id: llog.h,v 1.3 1999/12/30 14:49:52 mm Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#ifndef __L_LOG_H__
#define __L_LOG_H__


#include <fstream.h>
#include <ostream.h>

//#include <bits/std_fstream.h>
//#include <bits/std_iosfwd.h>

class LLog
{
public:

  // constructor
  LLog();

  // set a new target file name
  static void setTarget(const char *name);

  // output streams
  static ostream &output() { return *_output; };
  static ostream &log(const char *tag);


private:

  static ostream *_output;
  static char    *_filename;

};


// some abbreviations

inline ostream &log() { return LLog::log(" Log "); };
inline ostream &dbg() { return LLog::log("Debug"); };
inline ostream &err() { return LLog::log("Error"); };


#endif
