/****************************************************************************
**
** $Id: lmodemdb.cpp,v 1.6 2000/02/15 11:53:38 mhk Exp $
**
** Copyright (C) 1999 Calderasystems, Inc
** All rights reserved.
**
** This file is part of the Caldera OpenLinux Installer.
** Original Implementation: 1999 by Troll Tech AS
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE included in the packaging of this file.
**
*****************************************************************************/


#include <qfile.h>
#include <qtextstream.h>
#include <qregexp.h>
#include <qlistview.h>


#include "lglobal.h"
#include "lmodemdb.h"
#include "lutils.h"


LModemDB::LModemDB(QString filename)
{

//  printf("%s",filename.ascii());
  db.setAutoDelete(TRUE);

  LModemEntry *entry;

  QFile file(filename);
  if (file.open(IO_ReadOnly))
    {
      QTextStream is(&file);

      QRegExp white("\\s+");
      int     pos, len;
      QString key, val;
      
      entry = new LModemEntry;
      while (!is.eof())
	{
	  QString line = is.readLine();
	  if (line.left(1) == "#")
	    continue;

	  if (line.isEmpty() && !entry->model.isEmpty())
	    {
	      db.append(entry);
	      entry = new LModemEntry;
	      continue;
	    }

	  pos = white.match(line, 0, &len);
	  if (pos > 0)
	    {
	      key = line.left(pos);
	      val = line.mid(pos+len);

	      if (key == "model")
		entry->model = val;
	      if (key == "speed")
		entry->speed = val.toInt();
	      if (key == "flowHard")
		entry->hardCmd = AT(val);
	      if (key == "flowSoft")
		entry->softCmd = AT(val);
	      if (key == "init")
		entry->init = AT(val);
	      if (key == "device")
		entry->device = val;


		//old "if" code rewritten in a switch manner
		//added "device" key processing for non-standard cases
/*		switch (key){
				case "model":	   entry->model = val; 				break;
				case "speed":		 entry->speed = val.toInt();break;
				case "flowHard": entry->hardCmd = AT(val);	break;
	      case "flowSoft": entry->softCmd = AT(val);	break;
	      case "init":	   entry->init = AT(val);			break;
				case "device":	 entry->device = val;				break;
		};
  */

	    }
	}
      
    }      
}


