/***************************************************************************
                              lmonitor.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		 : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			 : http://www.bestlinux.net
    email		 : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LMONITOR_H
#define LMONITOR_H

#include "config.h"
#include "gblipage.h"

#include <qwidget.h>
#include <qdict.h>
#include <qlistview.h>

class QSpinBox;
class LMonitorType;
class QButtonGroup;
class QRadioButton;
class QFile;
class QTextStream;
class QLineEdit;
class QVBoxLayout;


// nifty little item that needs almost no heap space

class LMonitorType: public QListViewItem
{
public:
    LMonitorType( QListView *, const QString & );

    QString text( int ) const;
    QString key( int, bool ) const;
    void activate();

    static LMonitorType * standardMonitors;

private:
    QString t;
};


class LMonitor: public GBLIPage
{
    Q_OBJECT
public:
    LMonitor( QWidget * parent, const char * name = 0 );
    ~LMonitor();

    QString vendorName();
    QString modelName();
    QString horizSync();
    QString vertRefresh();
    int size();

    bool supportsHorizontalFrequency( float );
    bool supportsVerticalFrequency( float );

		void setMonitor( QString sMonitorVendor, QString sMonitorModel, int a_iHorzMin, int a_iHorzMax, int a_iVertMin, int a_iVertMax );

protected:
    void showEvent( QShowEvent*);

public slots:
		void finish() {}
		void setMode( int );

private slots:
    void spinBoxChanged( int );
    void lineEditChanged( const QString & );
    void readSomeMonitors();
    void monitorSelected();

private:
    void readMonitors();
    bool initialized;
	  int ReadMonitorsTypeFromINF( QString a_QSFileName );
  	int RetMinMaxSyncRange( QString a_QSFileName, QString a_QSModelKey, float *a_pfHorMin, float *a_pfHorMax, float *a_pfVertMin, float *a_pfVertMax );
		int getMountAnswer( char *data, int len );

    QVBoxLayout * l;
    QListView * monitors;
    QString monitor;
    float horizMin, horizMax, vertMin, vertMax;
    QLineEdit * monitorNameEdit;
    QSpinBox * hMinBox, * hMaxBox, * vMinBox, * vMaxBox;

		QWidget *listPanel;
		QWidget *customPanel;	
		QButtonGroup *bgMode;
		QRadioButton *rbPredefined;
		QRadioButton *rbInf;
		QRadioButton *rbCustom;

    QDict<LMonitorType> * vendors;
    QFile * f;
    QTextStream * ts;
    bool recursionHack;

		int iCurMode;
};


#endif









