/***************************************************************************
                           				log.h
                             -------------------                                         
    begin                : Sun Oct 31 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef LOG_H
#define LOG_H

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

// prints log messages and also saves them to the log file
// showing/printing depends on the given and common debug level
// usually it goes to NEWROOT/tmp/{install,upgrade}.log
// Debug level is controlled in GBLI through Ctrl+Alt+{U,I}
// U -> less messages
// I -> more messages
class Log {

public:
		Log( bool a_blUseLocal = false, char *a_szName = NULL );
		~Log();

		void log( int a_iDebugLevel, const char * s, ... );
		void close();

		// most widely used function:
		// if iDebugLevel is bigger than current then it is not printed
		// e.g. current iDebugLevel = 2
		// 0 - always printed to the log
		// 1 - currently printed to the log
		// 3 - not printed to the log
		// 32 - printed both to the log and stdout
		// 33 - currently printed both to the log and stdout
		// 35 - not printed
		static void logMain( int a_iDebugLevel, const char * s, ... );

		static void printl( int a_iDebugLevel, const char * s, ... );
		static void closeMain();
		static FILE * mainlog;
		static int iDebugLevel;
		static int iMaxDebug;

		// log file name
		static char *mainLogName;
private:
		void doLog( const char * s, va_list args );
		void printfLog( const char * s, va_list args );
		static void doLogMain( const char * s, va_list args );
		static void printfLogMain( const char * s, va_list args );

		FILE * logfile;
};

#endif


