/***************************************************************************
                                lsound.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Natalja Drozzina
    author email         : nd@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LSOUND_H
#define LSOUND_H

#include <qwidget.h>
#include <qframe.h>
#include <qradiobutton.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qapplication.h>
#include <qlistbox.h>
#include <qlayout.h>
#include <qslider.h>
#include <qfile.h>


#include "gblipage.h"

#define CONF_FILE "/etc/sysconfig/soundcard"
//#define KERN_FILE "/var/log/massages.kern"

class LSound: public GBLIPage
{
  Q_OBJECT

public:
    
  LSound(QWidget *parent, const char *name=0);
  ~LSound();

 bool b_enable;
 	
 int *ReturnType (){ return &iPubType; }
 int *ReturnCount (){ return &iPubCount; }
 int *ReturnIsfxLoad(){ return &isfx_result; }	

 void LoadMidi( int i_type );
/***********************************************/
int GetMixerValue (){ return mixer; }
void InitMixer(){ mixer = -1; }
void MixerOpen();
/***********************************************/

bool PubReadInfo(){
		return ReadInfo();
}
/***********************************************/
 QString *ReturnStr( int index ){

		switch(index)
		{
			case 0: 	default: return &sPubIRQ;	break;
			case 1: 	return &sPubIO;	break;			
			case 2: 	return &sPubDMA; break;			
			case 3:   return &sPubModulename; break;			
			case 4:   return &sPubDescr; break;				
			case 5:   return &sPubType; break;
      case 6:   return &sPubDMA2; break;
      case 7:   return &sPubMPU_IO; break;
      case 8:   return &sPubMPU_IRQ; break;
			case 9:		return &sPubMEM; break;
		}

  }

/***********************************************/
  QString CardTypeToString( int itype );
  bool LoadModule( QString str_module, int itype,
                            QString str_mpu_io,
                            QString str_mpu_irq,
														QString str_io,
														QString str_irq,
														QString str_dma,
														QString str_dma2,
														QString str_mem
 );

/***********************************************/
QLabel * GetLabel( int index ) {
	switch ( index ){
			case 0 : default: return label; break;
      case 1 : return lblAudio; break;
			case 2 : return lblSynth; break;
			case 3 : return lblMidi; break;
 			case 4 : return lblTimers; break;
			case 5 : return lblMixers; break;
			case 6 : return lblAudio_text; break;
			case 7 : return lblSynth_text; break;
			case 8 : return lblMidi_text; break;
			case 9 : return lblTimers_text; break;
			case 10: return lblMixers_text; break;
			case 11: return lblDigSnd; break;
			case 12: return lblMidiSnd; break;
			case 13: return lbl_volume; break;
			case 14: return lbl_balance; break;
	}
}
/***********************************************/
QPushButton *GetButton( int index ){
		switch ( index ){
				case 0 : default: return wav; break;
				case 1 : return midi; break;
		}
}	
/***********************************************/
QSlider *GetSlider( int index ){
		switch ( index ){
				case 0 : default: return slider1; break;
				case 1 : return slider2; break;
		}
}
/***********************************************/
QString GetPath(){ return spath_tmp; }

//	void RunMod( char *ch_program, char * );

  void finish();

  static bool hasSound();
  static bool hasMidi();
  static bool hasMixer();


  static bool sbAvailable;


	void WriteConfModules();	
	void WriteCardSettings( QString sCardType );	
	void LSound::VarsPubNull();

public slots:

  void testWav();
  void testMidi();
  void testMpg(); 
  void balanceChanged(int);
  void volumeChanged(int);

  void setMixer(int vol, int bal);
  void showDialog();

private:
  int isfx_result;
	
	QString spath_tmp;
	
	QLabel *label;
	QLabel *lblAudio;
	QLabel *lblSynth;
	QLabel *lblMidi;
	QLabel *lblTimers;
	QLabel *lblMixers;
	QLabel *lblDigSnd;
	QLabel *lblMidiSnd;
	QLabel *lbl_volume;
	QLabel *lbl_balance;

	QPushButton *wav;
	QPushButton *midi;	

	QSlider *slider1;
	QSlider *slider2;

	QLabel *lblAudio_text;
	QLabel *lblSynth_text;
	QLabel *lblMidi_text;
	QLabel *lblTimers_text;
	QLabel *lblMixers_text;


  int mixer;
  int volume, balance;
  QString strMod;

 // QString sCardType;
 // QGridLayout *grid;
  QVBoxLayout *vbox;

	bool CheckKernFile();

	int CardType();
  bool ReadInfo();
 //  QString sDescr;

 int GetModuleFromProc( QString str_description );
 bool EmuLoad();


/**/
  bool b_emu;
  int iPubType;
	int iPubCount;
 	QString sPubType;
  QString sPubIRQ;
  QString sPubIO;
	QString sPubDMA;
  QString sPubModulename;
  QString sPubDescr;
  QString sPubDMA2;
  QString sPubMPU_IO;
	QString sPubMPU_IRQ;
	QString sPubMEM;
	
	QString sProcDescr;
	QString sSynthDescr;

	void Sort( QArray < struct SoundCardsTable > sound_array, int size );
	void InitializeValues();	
	//void WriteConfModules();
//	void LoadMidi( int i_type );

};

/***************************************************/
class AdvSoundDialog: public QDialog
{
  Q_OBJECT

 public:
    AdvSoundDialog( QWidget* parent, LSound *Lsnd,  const char *name=0 );
   ~AdvSoundDialog() { }

//maybe to move to private.........
		void UnloadModules ( QString mod_name, int card_number );
   	
 private:		
	 LSound * sound;

   QListBox *listType;
   QComboBox *comboIO;
   QLabel *lblIO;
   QLabel *lblIRQ;
   QComboBox *comboIRQ;
   QLabel *lblDMA;
   QComboBox *comboDMA;	
	 QLabel *lblDMA2;
	 QComboBox *comboDMA2;
   QLabel *lblMPU_IO;
   QComboBox *comboMPU_IO;
   QLabel *lblMPU_IRQ;
   QComboBox *comboMPU_IRQ;	
   QLabel *lblMEM;
   QComboBox *comboMEM;
	 QLabel *lblHint_text;	

	 int FindItem( QString str_var, QComboBox *combo );	
   void init();
   bool bFirstShow;

	

 private slots:

  void ShowIO( int index );
  void NewCardSet( );
	void CloseAdv();	

 		
};
/***************************************************/




#endif


