 #include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h> 
#include <errno.h>


#include <qdir.h>
#include <lglobal.h>

#include "config.h"

#include "llog.h"

#include "lwriter.h"


LWriter::LWriter(QObject *parent, QString dir)
  : QObject(), _dir(dir)
{
  if (parent)
    connect(parent, SIGNAL(finish()), this, SLOT(write()));
}


bool makeDirs(QString path)
{
#ifdef GBLI_DEBUG
  dbg() << "mkdir " << path << endl;
#endif

  if (::mkdir(path.ascii(), 0755) >= 0 || errno == EEXIST)
    return true;
 
  if (errno == ENOENT)
    {
      int i;
 
      i = path.findRev('/');
      if (i > 0 && makeDirs(path.left(i))) {
        if (::mkdir(path.ascii(), 0755) >= 0)
          return true;
      }
    }  

  return false;
}


void LWriter::write()
{
  if (LGlobal::demo())
    return;

  if (makeDirs(_dir))
    doWrite();
}
