/***************************************************************************
                          modem.cpp  -  description                              
                             -------------------                                         
    begin                : Mon Aug 28 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "modem.h"

#include <stdlib.h>
/*#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qcombobox.h>*/

#include "log.h"
#define TEST_MODEM_DUP
//enable  filtering data in modules.conf,for string written twice


Modem::Modem( QWidget * parent, Mouse * mymouse, const char * name)
    : GBLIPage( parent, name )
{
/*  modem_probe = new LModemProbe;
	connect( modem_probe, SIGNAL( load_data() ), this, SLOT( load() ) );
  modem_probe->probe();*/

//  modemPort = mymouse->getPortName();
  saveMouse=mymouse;
  QGridLayout *grid = new QGridLayout(this, 2,6, 6,6);

  db = new LModemDB( QString( GBLI_DATA_PATH ) +"/data/modems" );

  model = new QComboBox(true, this);
	model->setFixedWidth(300);
  model->insertItem(tr("No modem"));
  QListIterator<LModemEntry> it(*db->entries());
  QStringList list;
  for (; it.current(); ++it)
    list.append(it.current()->model);
  list.sort();
  model->insertStringList(list);
  connect(model, SIGNAL(activated(const QString &)),
	  this, SLOT(modelChanged(const QString &)));
  grid->addMultiCellWidget(model, 0,0, 1,3, AlignLeft);

  QLabel *l = new QLabel(model, tr("&Model"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 0,0);

  device = new QComboBox(true, this);
	//add for acceleration
	m_DeviceList = deviceList();
  device->insertStringList(m_DeviceList);
  grid->addWidget(device, 1,1, AlignLeft);

  l = new QLabel(device, tr("&Device"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 1,0);

  speed = new QComboBox(this);
  speed->insertItem("14400");
  speed->insertItem("28800");
  speed->insertItem("33600");
  speed->insertItem("56000");
  speed->insertItem("64000");
  speed->insertItem("115200");
  grid->addWidget(speed, 2,1, AlignLeft);

  l = new QLabel(speed, tr("&Speed"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 2,0);

  flow = new QComboBox(this);
  flow->insertItem(tr("None"));
  flow->insertItem(tr("Hardware"));
  flow->insertItem(tr("Software"));
  grid->addWidget(flow, 3,1, AlignLeft);
  connect(flow, SIGNAL(highlighted(int)), this, SLOT(flowChanged(int)));

  l = new QLabel(flow, tr("&Flowcontrol"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 3,0);

  softcmd = new QLineEdit(this);
  grid->addWidget(softcmd, 4,1);

  l = new QLabel(softcmd, tr("&Command"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 4,0);

  hardcmd = new QLineEdit(this);
  grid->addWidget(hardcmd, 4,1);

  l = new QLabel(hardcmd, tr("&Command"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 4,0);

  init = new QLineEdit(this);
  grid->addWidget(init, 5,1);

  l = new QLabel(init, tr("&Initstring"), this);
	l->setAutoMask(true);
  grid->addWidget(l, 5, 0);

//  grid->setRowStretch(6,1);

//  flowChanged(1);
//  load();
}

void Modem::show()
{
    LModemData *data = LModemData::data();

    // FOR REMOVING PROBING
    data->setProbed(true);
    ///////////////////////

    load();


/*    if(!data->probed())
    {
      modem_probe = new LModemProbe;
	    connect( modem_probe, SIGNAL( load_data() ), this, SLOT( load() ) );
      strcpy( modem_probe->mousePort, saveMouse->getPortName() );

      modem_probe->probe();
    }*/ //No probing yet

    QWidget::show();
}

void Modem::hideEvent( QHideEvent * )
{
//		Log::logMain( 34, "Hiding modem window\n");
    save();
}

void Modem::flowChanged(int index)
{
	hardcmd->setEnabled(index != 0);
  softcmd->setEnabled(index != 0);

	switch (index)
	{
		case 1:
    	softcmd->hide();
    	hardcmd->show();
			break;
		case 2:
    	softcmd->show();
    	hardcmd->hide();
			break;
  };
//  printf("flow changed %d\n", index);
}


void Modem::modelChanged(const QString &model)
{
  // FIXME: Do not depend on i18n'ed strings!
	//warning: dangerous code
  bool none = model == tr("No modem");

  device->setEnabled(!none);
  flow->setEnabled(!none);
  speed->setEnabled(!none);
  softcmd->setEnabled(!none);
  hardcmd->setEnabled(!none);
  init->setEnabled(!none);

  if(none) return;

  QListIterator<LModemEntry> it(*db->entries());
  for (; it.current(); ++it) if (it.current()->model == model)
  {
	//add some code for processing non-standard soft modems
		device->clear();
		if	(!it.current()->device.isEmpty())
		{//now only one device can be contained
					//set non-standard device name
					//this code should be modified if modem has more than one
					//non-standard name
					device->insertItem(it.current()->device);
					//now we have only one non-standard device,so
				  //better to disable it
					device->setEnabled(none);		
		}// end of exception		
		else		
					device->insertStringList(m_DeviceList);	

	  flow->setCurrentItem(0);
		softcmd->setText(it.current()->softCmd);
	  hardcmd->setText(it.current()->hardCmd);
	  switch (it.current()->speed)
	  {
	    case 14400:
	      speed->setCurrentItem(0); break;
	    case 28800:
	      speed->setCurrentItem(1); break;
	    case 33600:
	      speed->setCurrentItem(2); break;
	    case 56000:
	      speed->setCurrentItem(3); break;
	    case 64000:
	      speed->setCurrentItem(4); break;
	    case 115200:
	      speed->setCurrentItem(5); break;
	    default:
	      speed->setCurrentItem(0); break;	
	  }
	  init->setText(it.current()->init);
  }
}

void Modem::load()
{
  LModemData *data = LModemData::data();

  emit nextEnabled(this, data->probed());

  if(!data->probed()) qApp->setOverrideCursor( Qt::waitCursor );
  if(data->probed())
  {
    qApp->restoreOverrideCursor();
    qApp->restoreOverrideCursor();
  }
  device->setEditText(data->device());
  //model->setCurrentItem(1);
  if (data->vendor().isEmpty())
    model->setEditText(data->model());
  else
    model->setEditText(data->vendor() + " " + data->model());

  // TODO: mark the right entry in the list

  flow->setCurrentItem((int)data->flow());
  softcmd->setText(data->softCommand());
  hardcmd->setText(data->hardCommand());
  switch (data->speed())
    {
	    case 14400:
	      speed->setCurrentItem(0); break;
	    case 28800:
	      speed->setCurrentItem(1); break;
	    case 33600:
	      speed->setCurrentItem(2); break;
	    case 56000:
	      speed->setCurrentItem(3); break;
	    case 64000:
	      speed->setCurrentItem(4); break;
	    case 115200:
	      speed->setCurrentItem(5); break;
	    default:
	      speed->setCurrentItem(0); break;	
    }

  init->setText(data->initString());

  if (!data->exists())
    {
      model->setCurrentItem(0);
//      if(model->text)model->setEditText(tr("No modem"));
    }

  bool none = !data->exists();

  device->setEnabled(!none);
  flow->setEnabled(!none);
  speed->setEnabled(!none);
  softcmd->setEnabled(!none);
  hardcmd->setEnabled(!none);
  init->setEnabled(!none);
  flowChanged((int)data->flow());

  device->setFocus();
}

/*int Modem::returnModemPort()
{
  return 666;
} */

/*void Modem::nextON()
{
  emit nextEnabled(this, true);
}

void Modem::nextOFF()
{
  emit nextEnabled(this, false);
}*/

void Modem::save()
{
  int pos;

  LModemData *data = LModemData::data();

  QString dev = device->currentText();
  pos = dev.find("(");
  if (pos >= 0)
    dev = dev.left(pos);
  data->setDevice(dev);

  QString ven, mod = model->currentText();
  pos = mod.find(" ");
  if (pos >= 0)
    {
      ven = mod.left(pos);
      mod = mod.mid(pos+1);
    }
  data->setModel(mod);
  data->setVendor(ven);

  data->setFlow((LModemData::Flow)flow->currentItem());
  data->setSoftCommand(softcmd->text());
  data->setHardCommand(hardcmd->text());
  data->setInitString(init->text());

  switch (speed->currentItem())
    {
    case 0:
      data->setSpeed(14400); break;
    case 1:
      data->setSpeed(28800); break;
    case 2:
      data->setSpeed(33600); break;
    case 3:
      data->setSpeed(56000); break;
		case 4:
      data->setSpeed(64000); break;
		case 5:
      data->setSpeed(115200); break;
    default:
      data->setSpeed(56000); break;
    }

  data->setExists(model->currentText() != tr("No modem"));
}

void Modem::updateWidgets()
{
//  model.text
	LModemData *data = LModemData::data();

//	printf("Modem model: %s\n", data->model().ascii());
	model->setEditText(data->model().ascii());
	flow->setCurrentItem(data->flow());
	softcmd->setText(data->softCommand());
	hardcmd->setText(data->hardCommand());
	init->setText(data->initString());
	device->setCurrentItem(data->device().right(1).toInt());
  switch (data->speed())
    {
	    case 14400:
	      speed->setCurrentItem(0); break;
	    case 28800:
	      speed->setCurrentItem(1); break;
	    case 33600:
	      speed->setCurrentItem(2); break;
	    case 56000:
	      speed->setCurrentItem(3); break;
	    case 64000:
	      speed->setCurrentItem(4); break;
	    case 115200:
	      speed->setCurrentItem(4); break;
	    default:
	      speed->setCurrentItem(0); break;	
    }
}

QStringList Modem::deviceList()
{
  QStringList devices;

  // serial devices
  QFile f(/*NEWROOT+*/"/proc/tty/driver/serial");
  QString port = /*NEWROOT+*/"/dev/ttyS%1(COM%2)";
  if (f.open(IO_ReadOnly))
    {
      QTextStream ts(&f);

      // skip driver version
      ts.readLine();

      while (true)
        {
          QString line = ts.readLine();
//          printf("line - %s\n",line.ascii());
          if (line.isEmpty())
            break;

          if (line.find("unknown") >= 0)
            continue;

          int portnr = line.left(1).toInt();
//					printf("Appeding %s\n", (const char*)port.arg(portnr).arg(portnr+1));
          devices.append(port.arg(portnr).arg(portnr+1));
        }
    }

  return devices;
}

void Modem::finish()
{
//  printf("Writing modem data...\n");
//  Log::logMain(32, "Writing modem data");
  LModemData *data = LModemData::data();

	if (!data->exists()) 
	{
		Log::logMain(32, "Modem is not set!\n");
		return;
	}

// TODO: /etc/ppp seems to be not required by LSB,
// so we couldn't not rely on it,
// may be it's correct place /etc/opt/ppp ?

	Log::logMain(32, "Modem is set!");
  makeDirs(NEWROOT+"/etc/ppp/starter/modems");
  QFile f(NEWROOT+"/etc/ppp/starter/modems/modem");
  if (f.open(IO_WriteOnly))
    {
      QTextStream conf(&f);

      conf << "[Modem]" << endl;
      conf << "Speed=" << data->speed() << endl;
      conf << "InitString=" << data->initString() << endl;
      conf << "HardFlowControlString=" << data->hardCommand() << endl;
      conf << "SoftFlowControlString=" << data->softCommand() << endl;
      conf << "[GBLI]" << endl; // ??? just our info or what?
      conf << "Model=" << data->vendor() << " " << data->model() << endl;
      conf << "Active=" << (data->exists() ? "true" : "false") << endl;
      conf << "FlowCtrl=";
      switch (data->flow())
	{
	case LModemData::None:
	  conf << "none" << endl; break;
	case LModemData::Software:
	  conf << "soft" << endl; break;	
	default:
	  conf << "hard" << endl; break;
	}

      conf << flush;
      f.close();
    }

	char	cmdstr[100];
	sprintf(cmdstr,"mknod %s/dev/ppp c 108 0", NEWROOT.ascii());
	
	system(cmdstr);
	//clear some duplicating data
	//in a case,if info will be taked from module-info
	//see below,to check which strings we find
	system(("sed -e \"/ptserial/d\" "+NEWROOT+"/etc/modules.conf |sed -e \"/lt_serial/d\"|sed -e \"/sm56/d\" >"+NEWROOT+"/etc/modules.tmp").latin1());
	system(("mv "+ NEWROOT+"/etc/modules.tmp "+ NEWROOT+"/etc/modules.conf").latin1());

	QFile ff(NEWROOT+"/etc/modules.conf");
	if (ff.open(IO_ReadWrite | IO_Append))
	{
		QTextStream conf(&ff);
		
		conf << "alias char-major-108    ppp_generic" << endl;
		conf << "alias /dev/ppp          ppp_generic" << endl;
		conf << "alias tty-ldisc-3       ppp_async" << endl;
		conf << "alias tty-ldisc-14      ppp_synctty" << endl;
		conf << "alias ppp-compress-21   bsd_comp" << endl;
		conf << "alias ppp-compress-24   ppp_deflate" << endl;
		conf << "alias ppp-compress-26   ppp_deflate" << endl;

		//support of NON-STANDARD MODEMS (SOFTWARE)
		if (!data->device().isEmpty())
		{
			//Log::logMain(2,"data->device() %s",data->device().latin1());
			//WARNING! find data should be synchronized with data/modems file's data
			///NOT DONE:resolving alias duplication conflicts
			if (data->device().find("/dev/ttyS15")>=0) //PCTEL789
					conf << "alias char-major-62    ptserial" << endl;
			if (data->device().find("/dev/ttyLT0")>=0) //LT WinModem
					conf << "alias char-major-62    lt_serial" << endl;
			if (data->device().find("/dev/sm56")>=0) //Motorola SM56 Soft
					conf << "alias char-major-24    sm56" << endl;		
		}
		
		conf << flush;
		ff.close();
	}
// create link  /dev/modem -> device,that is need for proper
// and comfortable support in many communication applications
//UNBIND /dev dir
///USUAL TEMPLATE
	bool bRemount=false;
	int res;
	if(!system(("mount |grep \"on " + NEWROOT + "/dev\" &>/dev/null").latin1()))
		{
			res = system(("umount "+ NEWROOT +"/dev").latin1());
			Log::logMain( 38, "Unmounting %s/dev: %d", NEWROOT.latin1(), res );
      bRemount = true;
    }
////////do what we need without binded /dev dir
		::unlink( (NEWROOT +"/dev/modem").latin1() );
		if (data->device().isEmpty())
			//show error message in a case of error
		  Log::logMain(2,"Modem page:data->device().IsEmpty()");
		else
		::symlink(data->device().latin1(),  (NEWROOT +"/dev/modem").latin1());
/////////////////////////////

if (bRemount){
#ifdef DEVFS
		res = system( ("mount -t devfs none "+ NEWROOT +"/dev").latin1() );
		Log::logMain( 38, "Mounting  %s/dev: %d", NEWROOT.latin1(), res );
#else
		res = system( ("mount --bind /dev "+ NEWROOT +"/dev").latin1() );
		Log::logMain( 38, "Mounting  %s/dev: %d", NEWROOT.latin1(), res );		
#endif
}
//END OF USUAL TEMPLATE


}


Modem::~Modem()
{
}

