/***************************************************************************
                          modem.h  -  description                              
                             -------------------                                         
    begin                : Mon Aug 28 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Oleg Golovachov (Demiurg)
    author email         : og@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/





#ifndef MODEM_H
#define MODEM_H

#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qapplication.h>

#include <stdio.h>

#include "lmodemdata.h"
#include "lmodemdb.h"
// #include "lmodemprobe.h" no probing yet
#include "config.h"
#include "mouse.h"
#include "lwriter.h"
#include "qdir.h"

#include "gblipage.h"
//#include "ltemplate.h"

//#include <qwidget.h>

/**
  *@author Oleg Golovachov (Demiurg)
  */

class Modem: public GBLIPage {
  Q_OBJECT
public:
	Modem( QWidget * parent, Mouse * mymouse, const char * name = 0);
  void show();
	void finish();
	void updateWidgets();
  ~Modem();

	LModemData *getModemData(){ return LModemData::data(); };

signals:
  void nextEnabled(QWidget*, bool);
//    void load_data();

public:

  void save();

protected:

//  void save();
  void hideEvent( QHideEvent * );

  QStringList deviceList();


private slots:

  void load();
//  int returnModemPort();
//  void nextON();
//  void nextOFF();

  void flowChanged(int index);
  void modelChanged(const QString &model);


private:

//    QLineEdit * p1;
   QComboBox * model;
   QLabel * l;
   QComboBox * flow;
   QLineEdit * softcmd;
   QLineEdit * hardcmd;
   QLineEdit * init;
   QComboBox * device;
   QComboBox * speed;
   LModemDB  * db;
//   LModemProbe * modem_probe; No probing yet
   LModemData * mydata;
   Mouse * saveMouse;

   QStringList m_DeviceList;
/*public:
   char modemPort[20];*/
//   LModemData *data;
};

#endif
