/***************************************************************************
                          printercfg.h  -  description                              
                             -------------------                                         
    begin                : Fri Feb 11 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Natalja Drozzina
    author email         : nd@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#ifndef PRINTERCFG_H
#define PRINTERCFG_H

#include <qwidget.h>
#include <qstring.h>
#include <qgroupbox.h>
#include <qlist.h>
#include <qstringlist.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qcheckbox.h>

#include "lnetwork.h"
#include "config.h" // general defines

#define ARRAY_SIZE 3
#define PROC "/proc"
#define SPOOL_BY_DEFAULT "/var/spool/lpd/lp"
#define PRINTER_FILTER_DIR "/usr/lib/rhs/rhs-printfilters/"
//#define GBLI_DEVEL

class QLabel;
class QListBox;

class PrnEntry
{
	public:
    PrnEntry( QString *StartEntry,
              QString *Description,
              QString *GSDriver,
              QStringList *Resolution,
              QStringList *BitsPerPixel ){ sentry = StartEntry;
																					 sdescr = Description;
                                           sgsdriver = GSDriver;
                                           slresol = Resolution;
                                           spixel = BitsPerPixel;
                                         }


    QString *GetEntry() {return sentry;}
    QString *GetDescription() {return sdescr;}
    QString *GetGSDriver() {return sgsdriver;}
    QStringList *GetResolList() {return slresol;}
    QStringList *GetBitsPerPixel() {return spixel; }

  private:
    QString *sentry;
    QString *sdescr;
    QString *sgsdriver;
    QStringList *slresol;
    QStringList *spixel;

};

/*********************************************/

class PrinterCfg : public QWidget  {

   Q_OBJECT

public: 
	PrinterCfg( QWidget *parent=0, const char *name=0 );

	~PrinterCfg();

	enum { Local=0, Remote, SMB, Netware };
  enum { Letter, Legal, Ledger, a3, a4 };

	void finish();

private slots:
  void ShowAdditional( int index );
  void ShowRes( int index );
  void TestPage ();

private:

  void NullValue();
  void setEnablLocal( bool bValue );
  void setEnablRemote( bool bValue );
  void setEnablSmb( bool bValue );
  void setEnablWare( bool bValue );
  void setEnablMain( bool bValue );

  QString *GetValue( QString sline );
  QStringList *DelBracket( QString *sline, int inum );

  int itemsCompare( QString str1, QString str2 );
  void Sort( int iLowBorder, int iTopBorder );

  void FillEntry();

  QString *DeviceFind();
  QGroupBox *FrameDraw();

  QWidget *LocalLayout( QGroupBox *gFrame );
  QWidget *RemoteLayout( QGroupBox *gFrame );
  QWidget *SmbLayout( QGroupBox *gFrame );
  QWidget *NetWareLayout( QGroupBox *gFrame );
  QWidget *groupAdd[ ARRAY_SIZE ];

  void MainLayout();

  int getCurIndex();

  void SwitchFields( bool bSwitch );

  QString ConvertType( int iCount );
  QString ConvertSize( int iCount );
  bool ResultValue();
  bool CreateSpoolDir( QString sSpoolP, QString sRootSpool );
  bool CreateConfigFile( QString input,
                         QString output,
                         QStringList *cFieldName,
                         QStringList *cFieldValue );

  bool CopyFilter( QString sSpool, QString sRootFilter );
  void EmptyFields();
  bool ConfigureQueue( QString sRoot );
  void CreatePrintcap( QString sRoot );

  QList<PrnEntry> list;
  QComboBox *cmbType;
  QListBox *listDriver;
  QLabel *lblPixel;
  QComboBox *cmbPixel;
  QLineEdit *editQueueMain;
  QLineEdit *editSpool;
  QComboBox *cmbSize;
  QLabel *lblRes;
  QComboBox *cmbRes;
  QCheckBox *chkStair;

  QLabel *lblType;
  QLabel *lblSize;
  QLabel *lblQueue;
  QLabel *lblSpool;

  QLabel *lblDevice;

  QComboBox *cmbDevice;

  QPushButton *butTest;

  LAddressEdit *editRemoteHost;
//  QLineEdit *editRemoteHost;
  QLineEdit *editQueueRemote;

  QLineEdit *editHost;
  LAddressEdit *editIP;
//  QLineEdit *editIP;
  QLineEdit *editName;
  QLineEdit *editUser;
  QLineEdit *editPass;
  QLineEdit *editWork;

//  QLineEdit *editNcpServer;
  LAddressEdit *editNcpServer;
  QLineEdit *editNcpQueue;
  QLineEdit *editNcpUser;
  QLineEdit *editNcpPass;

  QStringList *cFieldName;
  QStringList *cFieldValue;
  //QString sInput;
  //QString sOutput;



  QString sDriverResult;
  QString sDescription;
  QString sGSDriverResult;
  QString sTypeResult;
  QString sQueueResult;
  QString sSpoolResult;
//  QString sSpoolPath;
  QString sSizeResult;
  QString sResolResult;
  QString sPixel;
  QString sDescrPixel;
  QString sDevice;
  int iStair;

  QString sRemoteHost;
  QString sRemoteQueue;

  QString sSmbHost;
  QString sSmbIP;
  QString sSmbUser;
  QString sSmbName;
  QString sSmbPass;
  QString sSmbWorkgr;

  QString sNcpServer;
  QString sNcpQueue;
  QString sNcpUser;
  QString sNcpPass;

  QGroupBox *grBot;
  QLabel *lblHost;
  QLabel *lblQueueRemote;

  QLabel *lblSmbHost;
  QLabel *lblSmbIP;
  QLabel *lblSmbName;
  QLabel *lblSmbUser;
  QLabel *lblSmbPass;
  QLabel *lblWork;

  QLabel *lblServer;
  QLabel *lblNcpQueue;
  QLabel *lblNcpUser;
  QLabel *lblNcpPass;

  bool bPort;



};


#endif
