#include <sys/ioctl.h>

#include <qsockethack.h>

#include <llog.h>

//////////////////////////////////////////////////////////////////
// Implementation follows
//////////////////////////////////////////////////////////////////
QSocketNotifierHack::QSocketNotifierHack(int fd, Type type,
			const char *file, unsigned int line,
			QObject *parent, const char *name)
: QSocketNotifier(fd, type, parent, name),
  fileName(file),
  lineNumber(line),
  noData(0)
{
}

bool
QSocketNotifierHack::event(QEvent *e)
{
    QObject::event(e);
    if (e->type() == QEvent::SockAct) {
    	int	fd, avail = 0;

	fd = socket();
	if ((ioctl(fd, FIONREAD, &avail) < 0 || avail == 0) && ++noData > 100) {
	    // Use whatever logging mechanism lizard uses

	    log() << "QSocketNotifier allocated in " << fileName << ":" <<
		     lineNumber << ": zapping myself!" << endl;
	    setEnabled(false);
	    return FALSE;
	}

	noData = 0;
	log() << "Socket activated " << fd << "from " << fileName << ":" << lineNumber << endl;
	emit activated(fd);
	return TRUE;
    }

    return FALSE;
}
