/***************************************************************************
                          serviceinfo.cpp  -  description                              
                             -------------------                                         
    begin                : Sun May 27 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 : Anton Anisimov
    author email         : aa@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "serviceinfo.h"

ServiceInfo::ServiceInfo(){
}

ServiceInfo::~ServiceInfo(){
}

void ServiceInfo::setServiceName(QString a_sName){
	 sServiceName = a_sName;
}

void ServiceInfo::setServiceDescription(QString a_sDesc){
	sServiceDescription = a_sDesc;
}

void ServiceInfo::setExtranetStatus(bool a_bStatus){
	bExtranetServiceStatus = a_bStatus;
}

void ServiceInfo::setIntranetStatus(bool a_bStatus){
	bIntranetServiceStatus = a_bStatus;
}

void ServiceInfo::setServiceSettings( bool a_bNetType, QString a_sServiceName, QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue ){
	if ( a_bNetType == 0 ) {
		ServiceSettings *tmpS = new ServiceSettings( a_ConfFile, a_sName, a_sDescription, a_sValue );
		ServiceIntranet.append( tmpS );
	} else {
		ServiceSettings *tmpS = new ServiceSettings( a_ConfFile, a_sName, a_sDescription, a_sValue );
		ServiceExtranet.append( tmpS );
	}
}

void ServiceInfo::setExtranetServiceSettings( QString a_ServiceName, QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue ){
	setServiceSettings( 1, a_ServiceName, a_ConfFile, a_sName, a_sDescription, a_sValue );
}

void ServiceInfo::setIntranetServiceSettings( QString a_ServiceName, QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue ){
	setServiceSettings( 0, a_ServiceName, a_ConfFile, a_sName, a_sDescription, a_sValue );
}

QString ServiceInfo::getServiceName(){
	return sServiceName;
}
QString ServiceInfo::getServiceDescription(){
	return sServiceDescription;
}

bool ServiceInfo::getIntranetStatus() {
	return bIntranetServiceStatus;
}
bool ServiceInfo::getExtranetStatus() {
	return bExtranetServiceStatus;
}


QList<ServiceSettings> ServiceInfo::getIntranetServicesSettings() {
	return ServiceIntranet;
}
QList<ServiceSettings> ServiceInfo::getExtranetServicesSettings() {
	return ServiceExtranet;
}

ServiceSettings::ServiceSettings(){
#ifdef GBLI_DEVEL
	perror("ServiceSettings::ServiceSettings()");
#endif
}

ServiceSettings::ServiceSettings( QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue ){
	setConfigFileName( a_ConfFile );
	setParamName( a_sName );
	setParamDescription( a_sDescription );
	setParamValue( a_sValue );
#ifdef GBLI_DEVEL
	printf("ServiceSettings::ServiceSettings(a_ConfFile, a_sName, a_sDescription, a_sValue ) %s %s %s %s \n",a_ConfFile, a_sName, a_sDescription, a_sValue);
#endif

}

ServiceSettings::~ServiceSettings(){
}

void ServiceSettings::setConfigFileName( QString a_sFileName ){
	sConfigFileName = a_sFileName;
}
void ServiceSettings::setParamName( QString a_sName ){
	sParamName = a_sName;
}
void ServiceSettings::setParamDescription( QString a_sDesc ){
	sParamDescription = a_sDesc;
}
void ServiceSettings::setParamValue( QString a_sValue ){
	sParamValue = a_sValue;
}

QString ServiceSettings::getConfigFileName(){
	return sConfigFileName;
}
QString ServiceSettings::getParamName(){
	return sParamName;
}
QString ServiceSettings::getParamDescription(){
	return sParamDescription;
}
QString ServiceSettings::getParamValue(){
	return sParamValue;
}
