/***************************************************************************
                          serviceinfo.h  -  description                              
                             -------------------                                         
    begin                : Sun May 27 2001                                           
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd. 
    author		 : Anton Anisimov
    author email         : aa@bestlinux.net
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef SERVICEINFO_H
#define SERVICEINFO_H

#include <qstring.h>
#include <qlist.h>

/**
  *@author Anton Anisimov
  */

class ServiceSettings{
public:
	ServiceSettings();
	ServiceSettings( QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue );

	~ServiceSettings();

  void setConfigFileName( QString a_sFileName );
  void setParamName( QString a_sName );
  void setParamDescription( QString a_sDesc );
  void setParamValue( QString a_sValue );
  /**  */
  QString getConfigFileName();
  QString getParamName();
  QString getParamDescription();
	QString getParamValue();

private:
	QString sConfigFileName;
	QString sParamName;
	QString sParamDescription;
	QString sParamValue;	
};

class ServiceSettings;

class ServiceInfo {
public: 
	ServiceInfo();
	~ServiceInfo();
	
	void setServiceName(QString a_sName);
	void setServiceDescription(QString a_sDesc);
	void setExtranetStatus(bool a_bStatus);
	void setIntranetStatus(bool a_bStatus);
	void setExtranetServiceSettings( QString a_ServiceName, QString a_ConfFile, QString a_sParamName, QString a_sParamDescription, QString a_sParamValue );
	void setIntranetServiceSettings( QString a_ServiceName, QString a_ConfFile, QString a_sParamName, QString a_sParamDescription, QString a_sParamValue );
	inline void setProtocols(QString prot) { protocols = prot; }
	inline QString getProtocols()
	{
		if(protocols.length())
			return protocols;
		else
			return "";
	}

	QString getServiceName();
  QString getServiceDescription();
	bool getIntranetStatus();
	bool getExtranetStatus();

	QString GetDaemonName(){return m_strDaemonName;}
	QString GetChkConfigString(){return m_strChkConfigString;}
	
	void SetDaemonName (QString strDName ){m_strDaemonName = strDName ;}
	void SetChkConfigString (QString strChkConfig){m_strChkConfigString = strChkConfig ;}

	QList<ServiceSettings> getIntranetServicesSettings();
	QList<ServiceSettings> getExtranetServicesSettings();

//ServiceFile version
private:
//	QString sServiceFileModifDate;
//	QString sServiceFileVersion;
	QString sServiceName;
	QString sServiceDescription;
	QString protocols;
	bool bIntranetServiceStatus;
	bool bExtranetServiceStatus;
	QList<ServiceSettings> ServiceIntranet;
	QList<ServiceSettings> ServiceExtranet;

	QString m_strDaemonName;
	QString m_strChkConfigString;

	// a_bNetType = 0 - intranet, 1 - extranet
	void setServiceSettings( bool a_bNetType, QString a_sServiceName, QString a_ConfFile, QString a_sName, QString a_sDescription, QString a_sValue );
};

#endif

