/***************************************************************************
                          splitstring.h  -  description
                             -------------------
    begin                : Wed Jan 10 2001
    copyright            : (C) 2001 SOT Finnish Software Engineering Ltd.
    author		 					 : Sergei Bednoi, Vadim Khakhulin
    author email         : sb@bestlinux.net, vh@bestlinux.net
    url			 			: http://www.bestlinux.net
    email		 			: linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                        http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "splitstring.h"

SplitString::SplitString()
{
	sSections = "";
	cSeparator = ',';
	lastPos = nextPos = 0;
}

SplitString::SplitString(const char *init, const char sep = ',')
{
	sSections = init;
	cSeparator = sep;
	lastPos = nextPos = 0;
}

SplitString::~SplitString()
{
}

bool
SplitString::isEmpty()
{
	return (sSections=="");
}

void SplitString::setEmpty()
{
	sSections = "";	
}

void
SplitString::SetSeparatorChar(char cNewSeparator)
{
	cSeparator = cNewSeparator;
}

void
SplitString::SetSectionsString(const char* szNewString)
{
	sSections = szNewString;
	lastPos = nextPos = 0;
	cSeparator = ',';
}

//
// Function returns next section in sections string
// Parameters  : sNextSection - returned section name
// Return Value:	FALSE - error
//						TRUE - succsessful
//					

bool
SplitString::Next2(QString& sNextSection)
{
	int		iSize;
	
	if (sSections=="") return FALSE;
	iSize = sSections.find(cSeparator);
	
	if (iSize==-1)
	{
		sNextSection = sSections;
		sSections = "";
	}
	else
	{	
		sNextSection = sSections.left(iSize);
		sSections = sSections.right(sSections.length() - iSize - 1);
	}
	
	return TRUE;
}


bool SplitString::Next(QString& sNextSection)
{
	if(nextPos == -1 || !sSections.length())
	{
		nextPos = lastPos = 0;
		return false;		
	}

	nextPos = sSections.find(cSeparator, lastPos);

	if(nextPos == -1)
		sNextSection = sSections.right(sSections.length() - lastPos);
	else
	{	
		sNextSection = sSections.mid(lastPos, nextPos - lastPos);
		lastPos = nextPos + 1;
	}
	
	return true;
}

int SplitString::getIndex(QString findStr)
{
int index = -1;
int strAmount = getAmount();
int nextPos_ = nextPos;
int lastPos_ = lastPos;
QString nextStr;

	if(!sSections.length())
		return -1;

	nextPos = lastPos = 0;

	do {
		Next(nextStr);
		index++;
	} while(findStr != nextStr && index < strAmount);

	nextPos = nextPos_;
	lastPos = lastPos_;

	if(index >= strAmount)
		return -1;

	return index;
}

void SplitString::delByIndex(int index)
{

}

QString SplitString::getByIndex(int index)
{
int _index = -1;
int nextPos_ = nextPos;
int lastPos_ = lastPos;
QString nextStr;

	if(index < 0 || index > getAmount() - 1)
		return QString("");

	nextPos = lastPos = 0;

	do {
		Next(nextStr);
		_index++;
	} while(_index != index);
	
	nextPos = nextPos_;
	lastPos = lastPos_;

	return nextStr;
}

void SplitString::addSection(const QString add)
{
	if(sSections.length())
		sSections += cSeparator;
	sSections += add;
}

void SplitString::operator=(SplitString &split)
{
	sSections = split.returnSections();
	cSeparator = split.cSeparator;
	lastPos = nextPos = 0;
}

void SplitString::operator=(const QString newStr)
{
	sSections = newStr;
	lastPos = nextPos = 0;
}

void SplitString::operator=(const char *newStr)
{
	sSections = newStr;
	lastPos = nextPos = 0;
}
