/***************************************************************************
                              sysconfigfile.cpp
                             -------------------                                         
    begin                : Thu Nov 11 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "sysconfigfile.h"
# include "log.h"

void SysConfigFile::set(const char *var, const char *value, bool withQuotation )
{
    int		len;
    char	**sp;

    len = strlen(var);
    if (!value)
			value = "";
			
    for( sp = data; sp && *sp; sp++ ){
    	if( !strncmp(*sp, var, len) && (*sp)[len] == '=' ) {
    	    char *line;

    	    line = (char *) malloc(len + strlen(value) + 4);
// by Demiurg   	    line = (char *)new char[ len + strlen(value) + 4 ];
    	    if( line == '\0' ){
		    		Log::logMain(32, "out of memory in set(%s, %s)\n", var, value );
    				return;
    	    }
					if( withQuotation )
	    	    sprintf(line, "%s=\"%s\"", var, value);
					else
	    	    sprintf(line, "%s=%s", var, value);
    	    free(*sp);
//	by Demiurg				delete sp;
    	    *sp = line;
    	    return;
    	}
    }

    // if not found, lets add it to the end
    QString line;
		if( withQuotation )
      line.sprintf( "%s=\"%s\"", var, value );
    else
      line.sprintf( "%s=%s", var, value );
    append( line );
}

bool SysConfigFile::get(const char *var, char* value, int bufsize, char SepChar = '=')
{
    int		len;
    char	**sp;
//		char	buf[128];

    len = strlen(var);
			
    for( sp = data; sp && *sp; sp++ )
		{
			QString sCurLine(*sp);

			if (sCurLine.find('#', 0) != -1)
				sCurLine = sCurLine.left(sCurLine.find('#', 0));
			sCurLine = sCurLine.simplifyWhiteSpace();
			if (sCurLine.find(var, 0, FALSE) != -1)
			{
				if (sCurLine.find(SepChar) != -1)
				{
        	sCurLine = sCurLine.right(sCurLine.length() - sCurLine.find(SepChar, 0) - 1);

					if ((sCurLine[0] == '\"') && (sCurLine[sCurLine.length() - 1]) == '\"')
						sCurLine = sCurLine.mid(1, sCurLine.length() - 2);
	    	
					strcpy(value, sCurLine.ascii());					
					return true;
				}
    	}
    }
		strcpy(value, "");
		return false;
}

