/***************************************************************************
                                xserver.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef XSERVER_H
#define XSERVER_H

#include <qglobal.h>
#include <qstring.h>

// detects, tunes and runs XServer
class XServer{
public:
    XServer();
    ~XServer();

    bool serverRunning() const { return r; }
    
    static const QString path() { return "/usr/X11R6/bin/"; } ;

		int startKWM();

		void XServer::killX();

		static QString getXConfigString( QString fileName, QString section, QString parameter );
		
		static bool runSVGA;
		static bool runS3Trio;		

		// remove cyrillic fonts from xfs config
		static void removeCyrillicFonts();

		static bool safe_mode;

private:
		// checks if it allows SVGA mode, makes autoprobing
		bool allowsSVGA();
		// tune that XF86Config generated by X automatically to reflect our needs
		bool tuneUpXConfig( QString fileName );
		void setupMouse();
		void setupS3Trio();
    bool ReadMouseXFreeInfo( const char *a_szPath, QString *a_pQSMType );

    bool r;
    int xpid, kwmpid;
};


#endif


